﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * NoteBook Facebook Fan Template
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook
{
	import caurina.transitions.Tweener;
	import com.activetofocus.facebook.view.BackgroundPanel;
	import com.activetofocus.facebook.view.MainPreloaderPanel;
	import com.activetofocus.facebook.view.BottomPanel;
	import com.activetofocus.facebook.view.MenuPanel;
	import com.activetofocus.facebook.view.CenterPanel;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.QloaderItem;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.GetURL;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.text.TextField;
	import flash.events.*;
	
	
	public class FacebookMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * config data
		 */
		private var _config			:String = "xmlsetting/main_config.xml";
		private var _xml			:XML;
		
		private var _bgstyle		:Object;
		
		/**
		 * menus array
		 */
		private var _menuArray		:Array;
		private var _menuLength		:int;
		
		private var _nowSelect		:int;
		
		private var _isInit:Boolean = true;
		
		/**
		 * load array
		 */
		private var _hadLoad		:Array = [];
		
		/**
		 * panel
		 */
		private var _contentPanel:Sprite;
		private var _mainPreloaderPanel:MainPreloaderPanel;
		private var _backgroundPanel:BackgroundPanel;
		private var _centerPanel:CenterPanel;
		private var _bottomPanel:BottomPanel;
		private var _menuPanel:MenuPanel;
		
		
		/**
    	 *  constructor
     	 */
		public function FacebookMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			this.stage.align = StageAlign.TOP_LEFT;
	    	this.stage.scaleMode = StageScaleMode.NO_SCALE;
			this.stage.showDefaultContextMenu = false;

			addContentPanel();
			addMainPreloader();
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * add all site element panel
		 */
		private function addContentPanel():void
		{
			_contentPanel = new Sprite();
			addChild(_contentPanel);
		}
		 
		/**
		 * add main preloader
		 */
		private function addMainPreloader():void
		{
			_mainPreloaderPanel = new MainPreloaderPanel();
			_mainPreloaderPanel.x = 260;
			_mainPreloaderPanel.y = 300;
			addChild(_mainPreloaderPanel);
		}
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			_mainPreloaderPanel.open();
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 *  analyze xml files
		 */
		private function analyzeXML():void
		{
			//style
			_bgstyle = { };
			_bgstyle.alpha 		= Number(_xml.style.background.@alpha);
			_bgstyle.delay		= Number(_xml.style.background.@delay);
			_bgstyle.switchdelay= Number(_xml.style.background.@switch_delay);
			_bgstyle.effect		= int(_xml.style.background.@effect);
			_bgstyle.mask		= _xml.style.background.@mask == "true";
			
			_menuArray 		= [];
			_menuLength		= _xml.menus.menu.length();
			
			for(var i:int = 0; i<_menuLength; i++)
			{
				_menuArray.push(getMenuObject(_xml.menus.menu[i]));
			}
			
			
			addBackground();
		}
		
		/**
		 * add background
		 */
		private function addBackground():void
		{
			_backgroundPanel = new BackgroundPanel(_bgstyle,{onStart:onBackgroundStart,onProgress:onBackgroundProgress,onComplete:onBackgroundComplete});
			_contentPanel.addChild(_backgroundPanel);
			_backgroundPanel.changeBackground(String(_xml.style.background.@default));
		}
		
		private function addCenter():void
		{
			_centerPanel = new CenterPanel({onStart:onCenterPanelStart,onComplete:onCenterPanelComplete,onProgress:onCenterPanelProgress,onChangeBackground:onCenterPanelChange});
			_contentPanel.addChild(_centerPanel);
		}
		
		/**
		 * add bottom
		 */
		private function addBottom():void
		{
			_bottomPanel = new BottomPanel(_xml);
			_bottomPanel.x = 430;
			_contentPanel.addChild(_bottomPanel);
		}
		
		/**
		 * add menu
		 */
		private function addMenu():void
		{
			_menuPanel = new MenuPanel(_menuArray, { 
							align:_xml.menus.@align,
							x:Number(_xml.menus.@x),
							y:Number(_xml.menus.@y),
							height:Number(_xml.menus.@height),
							spacing:Number(_xml.menus.@spacing),
							bgcolor:uint(_xml.menus.@bgcolor),
							bgalpha:Number(_xml.menus.@bgalpha),
							fontsize:int(_xml.menus.@fontsize),
							textdefaultcolor:uint(_xml.menus.@textdefaultcolor),
							textselectcolor:uint(_xml.menus.@textselectcolor),
							textovercolor:uint(_xml.menus.@textovercolor) }, menuComplete, menuClick);
			_menuPanel.x = 415;
			_menuPanel.y = 310;
			_contentPanel.addChild(_menuPanel);
		}
		
		/**
		 *  get menu object
		 */
		private function getMenuObject(xml:*):Object
		{
			trace(xml.@xml)
			var obj:Object	= 	{ };
			obj.id			=   xml.@id || "";
			obj.title 	   	=  	xml.@title || "";
			obj.link  	  	=  	xml.@link == "true";
			obj.src		  	=  	xml.@src || "";
			obj.width		=   xml.@width || 0;
			obj.height		=	xml.@height	|| 0;
			obj.position	=	xml.@position || "center";
			obj.effect		=	xml.@effect == "move" ? 0 : 1;
			obj.xml		  	=	xml.@xml || "";
			obj.bg			= 	xml.@background || "";
			return obj;
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * background element load start
		 */
		private function onBackgroundStart(params:*):void
		{
			
		}
		
		/**
		 * background element load progress
		 */
		private function onBackgroundProgress(params:*):void
		{
			//trace(params.bytesLoaded);
		}
		
		/**
		 * background element load complete
		 */
		private function onBackgroundComplete(params:*):void
		{
			
			if (_isInit)
			{
				_isInit = false;
				
				addCenter();
				addBottom();
				addMenu();
				
				_mainPreloaderPanel.close();
			}
		}
		
		/**
		 * menu add complete
		 */
		private function menuComplete():void
		{
			menuClick(0);
		}
		 
		/**
		 * menu click event
		 */
		private function menuClick(i:*):void
		{
			//trace("menuClick", i);
			if (_menuArray[i].link)
			{
				var arr:Array = _menuArray[i].src.split(",")
				GetURL.open(arr[0] || "", arr[1] || "_blank");
			}
			else
			{
				_nowSelect = i;
				
				_menuPanel.changeMenu(i);
				
				//trace(_menuArray[_nowSelect].bg,String(_menuArray[_nowSelect].bg).length)
				
				var url:String = _menuArray[i].src;
				
				if (String(_menuArray[i].xml).length > 0 && url.indexOf("?") == -1)
				{
					url += "?xml=" + _menuArray[i].xml;
				}
				
				//if (_menuArray[i].xml != null && _menuArray[i].xml.length > 0)
//				{
//					url += "?xml=" + _menuArray[i].xml;
//				}
				trace(_menuArray[i].xml + " --- " + "menuClick",url + " ---------- ");
				_centerPanel.changeModule(url, _menuArray[i].width, _menuArray[i].height , _menuArray[i].position, _menuArray[i].effect,getHadLoad());
			}
		}
		
		/**
		 * 
		 */
		private function getHadLoad():Boolean
		{
			var bool:Boolean = true;
			for (var i:int = 0; i < _hadLoad.length;i++ )
			{
				if (_hadLoad[i] == _menuArray[_nowSelect].src)
				{
					bool = false;
					break;
				}
			}
			return bool;
		}
		
		/**
		 *  load bg error
		 */
		private function onCenterPanelStart(params:Object = null):void
		{
			//trace("onCenterPanelStart");
			if (getHadLoad()) _mainPreloaderPanel.open(0.4);
		}
		
		/**
		 * load XML progress
		 */
		private function onCenterPanelProgress(params:Object):void
		{
			//_centerPanelProgress.textMc.progTxt.text = Math.ceil((params.bytesLoaded / params.bytesTotal) * 100) + "";
		}
		
		
		/**
		 * change background
		 */
		private function onCenterPanelChange():void
		{
			if (String(_menuArray[_nowSelect].bg).length != 0 && _menuArray[_nowSelect].bg != "")
			{
				_backgroundPanel.changeBackground(_menuArray[_nowSelect].bg);
			}
			else
			{
				_backgroundPanel.changeBackground(String(_xml.style.background.@default));
			}
		}
		
		/** 
		 *  load bg complete
		 */
		private function onCenterPanelComplete(params:Object = null):void
		{
			_hadLoad.push(params.src);
			_mainPreloaderPanel.close();
			
		}
		
	}
}