﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////
package com.activetofocus.facebook.components
{
	
	
	/**
	 * ComMusicPlayerComponent
	 *
	 * @version 1.0
	 * @since  2011-07-29
	 * @author activetofocus team
	 * @author's Blog blog.activetofocus.com
	 * @ATF Team Site www.activetofocus.com
	 */
	
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.SuperMovieClip;
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.display.StageDisplayState;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;

	public class ComMusicPlayerComponent extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * data
		 */
		private var _path:String;
		
		private var _auto:Boolean;
		
		/**
		 * state
		 */
		private var _isPlay:Boolean;
		
		/**
		 * button effect delay time
		 */
		private var _delay:Number = 0.2;
		
		/**
		 * 
		 */
		private var _soundChannel:SoundChannel;
		
		/**
		 * 
		 */
		private var _sound:Sound;
		
		private var _replay:Boolean;
		
		/**
    	 *  constructor
     	 */
		public function ComMusicPlayerComponent(path:String,auto:Boolean=true) 
		{
			_path = path;
			_auto = auto;
		}
		
		public function stopMusic():void
		{
			if (_isPlay)
			{
				_replay = true;
				onBtnMouseClick({currentTarget:playBtn})
			}
		}
		
		public function playMusic():void
		{
			if(_replay)
			{
				_replay = false;
				onBtnMouseClick({currentTarget:playBtn})
			}
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			init();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			Clear.removeEvent(playBtn,MouseEvent.MOUSE_OUT, onBtnMouseOut);
			Clear.removeEvent(playBtn,MouseEvent.MOUSE_OVER, onBtnMouseOver);
			Clear.removeEvent(playBtn,MouseEvent.CLICK, onBtnMouseClick);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * initialization
		 */
		private function init():void
		{
			playBtn.gotoAndStop(3);
			for (var i:int = 1; i <= 5;i++ )
			{
				this['wave_' + i].scaleY = 0.2;
			}
					
			load();
		}
		
		/**
		 *  load 
		 */
		private function load():void
		{
			_sound = new Sound();
			_sound.addEventListener(Event.COMPLETE, completeHandler);
            _sound.load(new URLRequest(_path));
		}
		
		/**
		 * play sound
		 */
		private function playSound():void
		{
			if (_soundChannel) _soundChannel.stop();
			if (_sound)
			{
				_soundChannel = _sound.play(0, 1000000);
				//_soundChannel.addEventListener(Event.SOUND_COMPLETE, on
			}
			_soundChannel.soundTransform = new SoundTransform(Number(7/10));
		}
		
		/**
		 * 
		 */
		private function setWave():void
		{
			for (var i:int = 1; i <= 5;i++ )
			{
				var k:Number = Number((Math.floor(Math.random() * 9) + 2) / 10);
				this['wave_' + i].scaleY = k;
			}
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * sound load complete
		 */
		private function completeHandler(evt:Event):void
		{		
			playBtn.buttonMode = true;
			playBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnMouseOut);
			playBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnMouseOver);
			playBtn.addEventListener(MouseEvent.CLICK, onBtnMouseClick);
			
			if (_auto)
			{
				playSound();
				_isPlay = true;
				playBtn.gotoAndStop(1);
			}
			else
			{
				
			}
		}
		 
		/**
		 * button mouse over event
		 */
		private function onBtnMouseOver(evt:MouseEvent):void
		{
			
			if(evt.currentTarget == playBtn)
			{
				if (_isPlay)
				{
					evt.currentTarget.gotoAndStop(2);
				}
				else
				{
					evt.currentTarget.gotoAndStop(4);
				}
			}
			else
			{
				if (evt.currentTarget.currentFrame == 3) return;
				evt.currentTarget.gotoAndStop(2);
			}
		}
		
		/**
		 * button mouse out event
		 */
		private function onBtnMouseOut(evt:*):void
		{
			if(evt.currentTarget == playBtn)
			{
				if (_isPlay)
				{
					evt.currentTarget.gotoAndStop(1);
				}
				else
				{
					evt.currentTarget.gotoAndStop(3);
				}
			}
			else
			{
				if (evt.currentTarget.currentFrame == 3) return;
				evt.currentTarget.gotoAndStop(1);
			}
		}
		
		/**
		 * button mouse click event
		 */
		private function onBtnMouseClick(evt:*):void
		{
			if(evt.currentTarget == playBtn)
			{
				if (_soundChannel) 
				{
					_soundChannel.stop();
					_soundChannel = null;
				}
				if (_isPlay)
				{
					_isPlay = false;
					evt.currentTarget.gotoAndStop(4);
					for (var i:int = 1; i <= 5;i++ )
					{
						this['wave_' + i].scaleY = 0.2;
					}
				}
				else
				{
					_isPlay = true;
					playSound();
					evt.currentTarget.gotoAndStop(2);
				}
			}
			else
			{
				if (!_soundChannel)
				{
					playSound();
					playBtn.gotoAndStop(1);
					_isPlay = true;
				}
				_soundChannel.soundTransform = new SoundTransform(Number(7/10));
			}
		}
		
		/**
		 * 
		 */
		private function onEnterFrame(evt:Event):void
		{
			if (_isPlay) setWave();
		}
	}
	
}