﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * MenuItem
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */


package com.activetofocus.facebook.components
{
	import caurina.transitions.Tweener;
	import com.activetofocus.facebook.MenuFont;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.text.*;
	
	public class MenuItem extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * text
		 */
		private var _nameTxt:TextField;
		private var _font:MenuFont = new MenuFont();
		
		/**
		 * text value
		 */
		private var _id:int;
		private var _text:String;
		
		/**
		 * style
		 * <menus height="22" spacing="8" bgcolor="0x000000" bgalpha="1" fontsize="14" textdefaultcolor="0xffffff" textselectcolor="0x0e7aae" 
textovercolor="0x0e7aae">
		 */
		private var _style:Object =
						{
							fontsize:14,
							textdefaultcolor:0xffffff,
							textselectcolor:0x000000,
							textovercolor:0x0e7aae
						};
						
		private var _clickFun:Function;
	
		private var _isClick:Boolean;
		 
		/**
    	 *  constructor
     	 */
		public function MenuItem() 
		{

		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
	
			
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		public function initData(id:int,text:String,style:Object,clickFun:Function):void
		{
			_id			= id;
			_text		= text;
			_clickFun 	= clickFun;
		}
		
		/**
		 * init
		 */
		private function init():void
		{
			this.buttonMode = true;
			this.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
			this.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
			this.addEventListener(MouseEvent.CLICK, onMouseClick);
			
			this.mouseChildren = false;
			
			_nameTxt = new TextField();
			addChild(_nameTxt);
			
			_nameTxt.embedFonts     = true;
			_nameTxt.mouseEnabled 	= false;
			_nameTxt.selectable 	= false;
			_nameTxt.antiAliasType  = AntiAliasType.ADVANCED;
			_nameTxt.autoSize       = TextFieldAutoSize.LEFT;
			_nameTxt.wordWrap       = false;
			
			_nameTxt.x 				= 3;
			_nameTxt.y 				= 2;
			
			bg.mc1.scaleX = 0;
			
			changeShow(1);
		}
		
		/**
		 *  get text
		 */
		public function get text():String
		{
			return _text;
		}
		
		/**
		 * set text state
		 */
		public function changeState(bool:Boolean):void
		{
			_isClick = bool;
			if (_isClick)
			{
				changeShow(3);
			}
			else
			{
				changeShow(1);
			}
		}
		
		/**
		 *  change text state
		 */
		private function changeShow(type:int):void
		{
			if (_text == "" || _text == null) return;
			_nameTxt.text = _text;
			switch(type)
			{
				case 1: _nameTxt.setTextFormat(new TextFormat(_font.fontName, int(_style['fontsize']), uint(_style['textdefaultcolor'])));
						Tweener.addTween(bg.mc1, { scaleX:0,time:0.5} );
						break;
				case 2: _nameTxt.setTextFormat(new TextFormat(_font.fontName, int(_style['fontsize']), uint(_style['textovercolor'])));
						Tweener.addTween(bg.mc1, { scaleX:0,time:0.5} );
						break;
				case 3: _nameTxt.setTextFormat(new TextFormat(_font.fontName, int(_style['fontsize']), uint(_style['textselectcolor'])));
						Tweener.addTween(bg.mc1, { scaleX:1,time:0.5} );
						break;
			}
			
			var rec:Rectangle = _nameTxt.getBounds(_nameTxt);
			bg.width = rec.width + 10;
		}

		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * mouse over event
		 */
		private function onMouseOver(evt:MouseEvent):void
		{
			if (_isClick) return;
			changeShow(2);
		}
		
		/**
		 * mouse over event
		 */
		private function onMouseOut(evt:MouseEvent):void
		{
			if (_isClick) return;
			changeShow(1);
		}
		
		/**
		 * 
		 */
		private function onMouseClick(evt:MouseEvent):void
		{
			if (_isClick) return;
			if (_clickFun != null && _clickFun is Function) _clickFun(_id);
		}
		
	}
	
}