﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * SocialIcons
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.components
{
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.SuperMovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	import flash.filters.ColorMatrixFilter;
	import flash.filters.GlowFilter;
	
	public class SocialIcons extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------

		/**
		 * data
		 */
		private var _params:XMLList;
		
		/**
    	 *  constructor
     	 */
		public function SocialIcons(params:XMLList) 
		{
			_params = params;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			if (_params.feed == "" || _params.feed.length == 0)  this["btn_" + 0].visible = false;
			if (_params.twitter == "" || _params.twitter.length == 0)  this["btn_" + 1].visible = false;
			if (_params.flickr == "" || _params.flickr.length == 0)  this["btn_" + 2].visible = false;
			if (_params.digg == "" || _params.digg.length == 0)  this["btn_" + 3].visible = false;
			if (_params.linkedin == "" || _params.linkedin.length == 0)  this["btn_" + 4].visible = false;
			if (_params.youtube == "" || _params.youtube.length == 0)  this["btn_" + 5].visible = false;
			
			var k:int = 0;
			var spacing:Number = 16 + Number(_params.@spacing);
			for (var i:int = 0; i < 6;i++ )
			{
				if (this["btn_" + i].visible == true)
				{
					this["btn_" + i].alpha = 0;
					this["btn_" + i].x = k * spacing;
					this["btn_" + i].buttonMode = true;
					this["btn_" + i].mouseChildren = false;
					this["btn_" + i].addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					this["btn_" + i].addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
					this["btn_" + i].addEventListener(MouseEvent.CLICK, onMouseClick);
					Tweener.addTween(this["btn_" + i], { time:0.6, delay:(i + 1) * 0.2, transition:"linear", alpha:1 } );
					k++;
				}
				else
				{
					Clear.removeChild(this["btn_" + i]);
					this["btn_" + i] = null;
				}
			}
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			for (var i:int = 0; i < 6;i++ )
			{
				if (this["btn_" + i].visible == true)
				{
					Clear.removeEvent(this["btn_" + i],MouseEvent.MOUSE_OVER, onMouseOver);
					Clear.removeEvent(this["btn_" + i],MouseEvent.MOUSE_OUT, onMouseOut);
					Clear.removeEvent(this["btn_" + i],MouseEvent.CLICK, onMouseClick);
				}
			}
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * social mouse over
		 */
		private function onMouseOver(evt:MouseEvent):void
		{
			for (var i:int = 0; i < 6;i++ )
			{
				if (this["btn_" + i] && this["btn_" + i].visible == true)
				{
					if (evt.currentTarget != this["btn_" + i])
					{
						this["btn_" + i].filters = [];
					}
					else
					{
						this["btn_" + i].filters = [new GlowFilter(0x269fd1, 1, 5, 5,3,2)];
					}
				}
			}
			
		}
		
		/**
		 * social mouse over
		 */
		private function onMouseOut(evt:MouseEvent):void
		{
			for (var i:int = 0; i < 6;i++ )
			{
				if (this["btn_" + i] && this["btn_" + i].visible == true)
				{
					this["btn_" + i].filters = [];
				}
			}
		}
		
		/**
		 * social mouse click
		 */
		private function onMouseClick(evt:MouseEvent):void
		{
			switch(evt.currentTarget.name)
			{
				case "btn_0" : GetURL.open(_params.feed.toString()); break;
				case "btn_1" : GetURL.open(_params.twitter.toString()); break;
				case "btn_2" : GetURL.open(_params.flickr.toString()); break;
				case "btn_3" : GetURL.open(_params.digg.toString()); break;
				case "btn_4" : GetURL.open(_params.linkedin.toString()); break;
				case "btn_5" : GetURL.open(_params.youtube.toString()); break;
			}
		}
		
	}
	
}