﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * AboutMain
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.modules.about
{
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.TextUtils;
	import flash.events.MouseEvent;
	import flash.display.*;
	
	public class AboutMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  xml data
		 */
		private var _config:String;
		private var _xml:XML;
		
		private var _sw:Number = 430;
		private var _sh:Number = 600;
		
		private var _delay:Number = 0.6;

		/**
		 * textfield
		 */
		private var _aboutTxt:TextUtils;
		
		/**
		 *  background 
		 */
		private var _bg:Sprite;
		 
		/**
    	 *  constructor
     	 */
		public function AboutMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			if (this.loaderInfo.parameters.xml != null)
			{
				_config = this.loaderInfo.parameters.xml || "";
			}
			else
			{
				_config = "xmlsetting/about_config.xml";
			}
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 * analyze XML data
		 */
		private function analyzeXML():void
		{
			_aboutTxt = new TextUtils();
			_aboutTxt.x = 5;
			_aboutTxt.y = 325;
			_aboutTxt.width = 400;
			_aboutTxt.height = 240;
			//_aboutTxt.mouseover = true;
			_aboutTxt.scrollbordercolor = 0xffffff;
			_aboutTxt.scrollcolor = 0xffffff;
			_aboutTxt.useBackground = false;
			_aboutTxt.scrolllinecolor = 0x0A0A0A;
			_aboutTxt.scrollalpha = 0.6;
			_aboutTxt.htmlText = _xml.content;
			addChild(_aboutTxt);
			
			addImage();
		}
		
		
		/**
		 * add Main image
		 */
		private function addImage():void
		{			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadImageError,itemCompleteFun:onLoadImageComplete,itemProgressFun:onLoadImageProgress});
			qloader.load(_xml.image.@src);
			qloader.execute();
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * load Main Image complete
		 */
		private function onLoadImageComplete(params:Object):void
		{
			var lo:Loader = params.data ;
			var newslide = new SlideUtils( { sw:400, sh:160, effect:7, number:20,delay:0.6, mc:lo, link:"", target:"" } );
			newslide.x = 5;
			newslide.y = 125;
			addChild(newslide);
		}
		
		/**
		 * load Main Image error
		 */
		private function onLoadImageError(params:Object):void
		{
			trace("onLoadImageError");
		}
		
		/**
		 * load Main Image progress
		 */
		private function onLoadImageProgress(params:Object):void
		{
			//trace(params.bytesLoaded,params.bytesLoaded)
		}
	}
}