﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * ComItemPanel
 *
 * @version 1.0
 * @since  2011-07-24
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.contact
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.PageUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.TextUtils;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.text.*;
	import com.activetofocus.utils.Clear;
	import flash.filters.DropShadowFilter;
	
	public class ComItemPanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _params:Object;
		
		private var _delay:Number = 0.5;
	
		private var _nowShowObj:*;
		
		private var _bool:Boolean;
		
		/**
		 * panel
		 */
		private var _bg:Sprite;
		private var _itemPanel:DisplayObjUtils;
		private var _buttonPanel:Sprite;
		
		/**
    	 *  constructor
     	 */
		public function ComItemPanel(params:Object) 
		{
			_params = params;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			this.stage.addEventListener(Event.RESIZE, onStageResize);
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			Clear.removeEvent(this.stage, Event.RESIZE, onStageResize);
			Clear.removeChild(this._bg);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * init all data
		 */
		private function init():void
		{
			this.alpha = 0;
			
			addBg();
			addItem();
			addButton();
			
			showItem();

			onStageResize();
			
			Tweener.addTween(this, { time:_delay*2, alpha:1,onComplete:onComplete} );
		}
		
		private function onComplete():void
		{
			Tweener.addTween(_buttonPanel, { time:_delay, alpha:1} );
		}
		
		/**
		 * add bg
		 */
		private function addBg():void
		{
			if (!_bg) 
			{
				_bg = new Sprite();
				addChild(_bg);
			}
			_bg.graphics.clear();
			_bg.graphics.beginFill(0x000000, 0.3);
			_bg.graphics.drawRect(0, 0, 520, 600);
			_bg.graphics.endFill();
		}
		
		/**
		 * add item
		 */
		private function addItem():void
		{
			_itemPanel =  new DisplayObjUtils();
			addChild(_itemPanel);
		}
		
		/**
		 * 
		 */
		private function addButton():void
		{
			_buttonPanel = new Sprite();
			_buttonPanel.alpha = 0;
			addChild(_buttonPanel);
			
			//_closeBtn = new ComGalleryCloseBtn();
//			_closeBtn.scaleX = _closeBtn.scaleY = 0.7;
//			_closeBtn.buttonMode = true;
//			_closeBtn.mouseChildren = false;
			this.buttonMode = true;
			this.addEventListener(MouseEvent.CLICK, onClosePanel);
			//_buttonPanel.addChild(_closeBtn);
	
		}
		
		/**
		 * show item
		 */
		private function showItem():void
		{
			_itemPanel.changeItem(_params['src'],_bool);
		}
		 
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  stage resize
		 */
		private function onStageResize(evt:* = null):void
		{
			addBg();
			
			if(_itemPanel)
			{
				_itemPanel.x = 520 / 2;
				_itemPanel.y = 600 / 2;
			}
		}
		
		/**
		 * close panel
		 */
		private function onClosePanel(evt:MouseEvent):void
		{
			this.mouseEnabled = false;
			Tweener.addTween(this, { time:_delay, alpha:0, onComplete:onCloseComplete } );
		}
		
		private function onCloseComplete():void
		{
			Clear.removeChild(this);
		}
	}
	
}