﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * ContactMain
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.modules.contact
{
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.DisplayLine;
	import flash.display.*;
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.net.*;
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.DisplayLine;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.TextUtils;
	import flash.events.*;

	public class ContactMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  xml data
		 */
		private var _config:String;
		private var _xml:XML;
		
		/**
		 * data connect php file
		 */
		private var _timer:Timer; // timer
		private var _urlload:URLLoader;
		private var _urlrequest:URLRequest;
		
		private var _sw:Number = 430;
		private var _sh:Number = 600;
		
		/**
		 * style
		 */
		private var _delay:Number = 0.3;
		
		private var _itemPanel:ComItemPanel;	
		
		/**
    	 *  constructor
     	 */
		public function ContactMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init();
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			if (this.loaderInfo.parameters.xml != null)
			{
				_config = this.loaderInfo.parameters.xml || "";
			}
			else
			{
				_config = "xmlsetting/contact_config.xml";
			}
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 * analyze XML data
		 */
		private function analyzeXML():void
		{
			addImage();
		}
		
		/**
		 * add Main image
		 */
		private function addImage():void
		{			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadImageError,itemCompleteFun:onLoadImageComplete,itemProgressFun:onLoadImageProgress});
			qloader.load(_xml.simg.@src);
			qloader.execute();
		}
		
		/**
		 * init
		 */
		private function init():void
		{			
			maskMc.alpha = 0;
			
			stateMc.visible = false;
			
			nameErrTxt.mouseEnabled = false;
			mailErrTxt.mouseEnabled = false;
			
			nameErrTxt.selectable = false;
			mailErrTxt.selectable = false;
			
			clearBtn.buttonMode = true;
			//clearBtn.alpha = 0.5;
			clearBtn.addEventListener(MouseEvent.CLICK,onBtnMouseClickEvent);
			clearBtn.addEventListener(MouseEvent.MOUSE_OVER,onBtnMouseOverEvent);
			clearBtn.addEventListener(MouseEvent.MOUSE_OUT,onBtnMouseOutEvent);
	
			sendBtn.buttonMode  = true;
			//sendBtn.alpha = 0.5;
			sendBtn.addEventListener(MouseEvent.CLICK,onBtnMouseClickEvent);
			sendBtn.addEventListener(MouseEvent.MOUSE_OVER,onBtnMouseOverEvent);
			sendBtn.addEventListener(MouseEvent.MOUSE_OUT,onBtnMouseOutEvent);
	
			nameTxt.addEventListener(FocusEvent.FOCUS_OUT,onTextFocusOutEvent);
			nameTxt.addEventListener(FocusEvent.FOCUS_IN,onTextFocusInEvent);
			
			mailTxt.addEventListener(FocusEvent.FOCUS_OUT,onTextFocusOutEvent);
			mailTxt.addEventListener(FocusEvent.FOCUS_IN,onTextFocusInEvent);
			
			msgTxt.addEventListener(FocusEvent.FOCUS_OUT,onTextFocusOutEvent);
			msgTxt.addEventListener(FocusEvent.FOCUS_IN,onTextFocusInEvent);
		}
		

		/**
 		 *  check name textfield
		 */
		private function checkNameText():void
		{
			if(nameTxt.text == "")
			{
				nameErrTxt.text = "* valid name!";
			}
			else
			{
				nameErrTxt.text = "";
			}
		}

		/**
		 *  check mail textfield
 		 */
		private function checkMailText():void
		{
			if(mailTxt.text == "")
			{
				mailErrTxt.text = "* valid email!";
			}
			else
			if(!authenticationEmail(mailTxt.text))
			{
				mailErrTxt.text = "* valid email!";
			}
			else
			{
				mailErrTxt.text = "";
			}
		}
		
		/**
 		 *  check massage textfield
		 */
		private function checkMsgText():void
		{
			if(msgTxt.text == "" || msgTxt.text == "Please enter message!")
			{
				msgTxt.text = "Please enter message!";
			}
		}

		/**
		 *  set click state
		 */
		private function setClickState(bool:Boolean = false):void
		{
			nameTxt.mouseEnabled  = bool;
			mailTxt.mouseEnabled  = bool;
			msgTxt.mouseEnabled   = bool;
			clearBtn.mouseEnabled = bool;
			sendBtn.mouseEnabled  = bool;
		}
		
		/**
		 *  authentication email format
		 */
		private function authenticationEmail(str:String):Boolean 
		{
			var p:RegExp = /(\w|[_.\-])+@((\w|-)+\.)+\w{2,4}+/;
			var r:Object = p.exec(str);
			if( r == null ) 
			{
				return false;
			}
			return true;
		}
		
		private function visibleObject():void
		{
			nameErrTxt.text = "";
			mailErrTxt.text = "";
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  clear,send button mouse click event
 		 */
		private function onBtnMouseClickEvent(evt:MouseEvent):void
		{
			if(stateMc.visible) stateMc.visible = false;
			if(evt.currentTarget == clearBtn)
			{
				nameTxt.text  =  "";
				mailTxt.text  =  "";
				msgTxt.text   =  "";
				visibleObject();
			}
			else
			{
				visibleObject();
	
				if(nameTxt.text !="" && mailTxt.text != "" && msgTxt.text != "")
				{
					if(authenticationEmail(mailTxt.text))
					{				
						setClickState();
				
						stateMc.gotoAndStop(1);
						stateMc.visible = true;
				
						_urlload = new URLLoader;
						_urlrequest = new URLRequest( "contact.php" );
						_urlrequest.method = URLRequestMethod.POST;
				
						var dataStr:String = "name=" + nameTxt.text
							   			+ "&email=" + mailTxt.text
							   			+ "&message=" + msgTxt.text;
						var urlVar:URLVariables = new URLVariables(dataStr);
						urlVar.dataFormat = URLLoaderDataFormat.TEXT;

						_urlrequest.data = urlVar;
				
						_urlload.load(_urlrequest);
						_urlload.addEventListener(Event.COMPLETE,onLoadCompleteEvent);
				
						_timer = new Timer(2500,1);
						_timer.addEventListener(TimerEvent.TIMER_COMPLETE,onTimerCompleteEvent);
						_timer.start();
					}
					else
					{
						checkMailText();
					}
				}
				else
				{
					checkNameText();
					checkMailText();
					checkMsgText();
				}
			}
		}

		/**
 		 *  clear,send button mouse over event
		 */
		private function onBtnMouseOverEvent(evt:MouseEvent):void
		{
			(evt.currentTarget as MovieClip).gotoAndStop(2);
			//Tweener.addTween(evt.currentTarget as DisplayObject, { time:_delay,alpha:1} );
		}

		/**
		 *  clear,send button mouse uut event
		 */
		private function onBtnMouseOutEvent(evt:MouseEvent):void
		{
			(evt.currentTarget as MovieClip).gotoAndStop(1);
			//Tweener.addTween(evt.currentTarget as DisplayObject, { time:_delay,alpha:.5} );
		}
		
		/**
		 *  textField focus out event
		 */
		private function onTextFocusInEvent(evt:FocusEvent):void
		{
			stateMc.visible = false;
			if(evt.currentTarget == nameTxt)
			{
				Tweener.addTween(nameBg.sp, { time:_delay, width:190} );
				//nameBg.gotoAndStop(2);
			}
			else if(evt.currentTarget == mailTxt)
			{
				Tweener.addTween(mailBg.sp, { time:_delay, width:190} );
				//mailBg.gotoAndStop(2);
			}
			else if(evt.currentTarget == msgTxt)
			{
			//	msgBg.gotoAndStop(2);
				Tweener.addTween(msgBg.sp, { time:_delay, width:280} );
				if(msgTxt.text == "Please enter message!") msgTxt.text = "";
			}
			
		}

		/**
		 *  textField focus out event
		 */
		private function onTextFocusOutEvent(evt:FocusEvent):void
		{
			if(evt.currentTarget == nameTxt)
			{
				Tweener.addTween(nameBg.sp, { time:_delay, width:0} );
				//nameBg.gotoAndStop(1);
				checkNameText();
			}
			else
			if(evt.currentTarget == mailTxt)
			{
				Tweener.addTween(mailBg.sp, { time:_delay, width:0} );
				//mailBg.gotoAndStop(1);
				checkMailText();
			}
			else
			{
				Tweener.addTween(msgBg.sp, { time:_delay, width:0} );
				checkMsgText();
			}
		}

		/**
		 *  send complete event
		 */
		private function onLoadCompleteEvent(evt:Event):void
		{
			_timer.removeEventListener(TimerEvent.TIMER_COMPLETE,onTimerCompleteEvent);
			_timer.stop();
			
			nameTxt.text  =  "";
			mailTxt.text  =  "";
			msgTxt.text   =  "";
						
			var backInfo = new URLVariables(evt.currentTarget.data).success;
	
			if(backInfo == "yes" )
			{
				stateMc.gotoAndStop(3);
				
				nameTxt.text  =  "";
				mailTxt.text  =  "";
				msgTxt.text   =  "";
			}
			else
			{
				stateMc.gotoAndStop(2);
			}
			setClickState(true);
		}

		/**
		 *  timer complete event
 		 */
		private function onTimerCompleteEvent(evt:TimerEvent):void
		{
			nameTxt.text  =  "";
			mailTxt.text  =  "";
			msgTxt.text   =  "";
						
			_urlload.removeEventListener(Event.COMPLETE,onLoadCompleteEvent);
			_timer.removeEventListener(TimerEvent.TIMER_COMPLETE,onTimerCompleteEvent);
			setClickState(true);
			stateMc.gotoAndStop(2);
		}
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * load Main Image complete
		 */
		private function onLoadImageComplete(params:Object):void
		{
			var lo:Loader = params.data ;
			var newslide = new SlideUtils( { sw:180, sh:120, effect:5, number:10,delay:0.6, mc:lo, link:"", target:"" } );
			newslide.x = 20;
			newslide.y = 138;
			maskMc.buttonMode = true;
			maskMc.addEventListener(MouseEvent.MOUSE_DOWN, onImageClick);
			maskMc.addEventListener(MouseEvent.MOUSE_OVER, onImageClick);
			maskMc.addEventListener(MouseEvent.MOUSE_OUT,onImageClick);
			addChildAt(newslide,1);
		}
		
		/**
		 * load Main Image error
		 */
		private function onLoadImageError(params:Object):void
		{
			trace("onLoadImageError");
		}
		
		/**
		 * load Main Image progress
		 */
		private function onLoadImageProgress(params:Object):void
		{
			//trace(params.bytesLoaded,params.bytesLoaded)
		}
		
		private function onImageClick(evt:MouseEvent):void
		{
			if (evt.type == MouseEvent.MOUSE_DOWN)
			{
				showItemPanel(_xml.bimg.@src);
			}
			else
			if (evt.type == MouseEvent.MOUSE_OVER)
			{
				Tweener.addTween(maskMc, { alpha:1, time:0.5 } );
			}
			else
			{
				Tweener.addTween(maskMc, { alpha:0, time:0.5 } );
			}
			
		}
		
		/**
		 * show item panel
		 */
		private function showItemPanel(src:String):void
		{
			Clear.removeChild(_itemPanel);
			_itemPanel = new ComItemPanel({src:src,closeFun:onItemPanelClose});
			this.stage.addChild(_itemPanel);
		}
		
		/**
		 * ITEM CLOSE
		 */
		private function onItemPanelClose():void
		{
			Clear.removeChild(_itemPanel);
		}
	}
	
}