﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * GalleryImagePanel
 *
 * @version 1.0
 * @since  2011-05-05
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.gallery
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.PageUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.TextUtils;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.text.*;
	import com.activetofocus.utils.Clear;
	import flash.filters.DropShadowFilter;
	
	public class GalleryImagePanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _delay:Number = 0.6;
		
		/**
		 * 
		 */
		private var _nowObj:Loader;
		
		/**
		 * loader
		 */
		private var _qloader:Qloader;
		
		/**
    	 *  constructor
     	 */
		public function GalleryImagePanel() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *
		 */
		public function changeImage(src:String):void
		{
			preloader.visible = true;
			if (_qloader) _qloader.removeAll();
			_qloader = new Qloader({itemIOErrorFun:onLoaderImageErrorEvent,itemCompleteFun:onLoaderImageCompleteEvent,itemProgressFun:onProgressEvent});
			_qloader.load(src);
			Tweener.removeTweens(_nowObj);
			if (_nowObj)
			{
				Tweener.addTween(_nowObj, { time:_delay, alpha:0, onComplete:onComplete,onCompleteParams:[_nowObj],transition:"linear" });
			}
			else
			{
				_qloader.execute();
			}
			
		}
		 
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		private function onComplete(obj:*):void
		{
			Clear.removeChild(obj);
			
			_qloader.execute();
		}
		
		/**
		 *  loader image error
		 */
		private function onLoaderImageErrorEvent(params:Object):void
		{
			trace("onLoaderImageErrorEvent");
		}
		
		/**
		 * load progress event
		 */
		private function onProgressEvent(params:Object):void
		{
			//if (_params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * loader complete
		 */
		private function onLoaderImageCompleteEvent(params:Object):void 
		{
			preloader.visible = false;
			_qloader = null;
			_nowObj = params.data as Loader;
			_nowObj.alpha = 0;
			_nowObj.x = -int(_nowObj.width / 2);
			_nowObj.y = -int(_nowObj.height / 2);
			Tweener.addTween(_nowObj, {time:_delay,alpha:1,transition:"linear" } );
			addChildAt(_nowObj,0);
			
		}
		
	}
	
}