﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * GalleryItem
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.gallery
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.PageUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.TextUtils;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.text.*;
	import com.activetofocus.utils.Clear;
	import flash.filters.DropShadowFilter;
	
	public class GalleryItem extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _params:Object;
		private var _delay:Number = 0.6;
		
		private var _loader:Sprite;
		
		/**
		 * panel
		 */
		private var _sp:Sprite;
		
		private var _isClick:Boolean;
		
		/**
    	 *  constructor
     	 */
		public function GalleryItem(params:Object,isClick:Boolean) 
		{
			_params = params;
			_isClick = isClick;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			Clear.removeEvent(this,MouseEvent.MOUSE_OVER, onBackBtnMouseOver);
			Clear.removeEvent(this,MouseEvent.MOUSE_OUT, onBackBtnMouseOut);
			Clear.removeEvent(this,MouseEvent.CLICK, onItemMouseClick);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		public function get id():int
		{
			return _params['id']
		}
		
		/**
		 * init all data
		 */
		private function init():void
		{
			maskMc.gotoAndStop(1);
			
			this.mouseChildren = false;
			this.buttonMode = true;
			this.addEventListener(MouseEvent.MOUSE_OVER, onBackBtnMouseOver);
			this.addEventListener(MouseEvent.MOUSE_OUT, onBackBtnMouseOut);
			this.addEventListener(MouseEvent.CLICK, onItemMouseClick);
			var qloader:Qloader = new Qloader({QloaderNumber:1,itemIOErrorFun:onLoadItemError,itemCompleteFun:onLoadItemComplete,itemProgressFun:onLoadItemProgress});
			qloader.load(_params['thumsrc']);
			qloader.execute();
			
		}
		
		/**
		 *
		 */
		public function changeState(bool:Boolean):void
		{
			_isClick = bool;
			if(_isClick)
			{
				//Tweener.addTween(maskMc, { alpha:1, time:_delay } );
				maskMc.gotoAndStop(2);
				if (_sp) _sp.filters = [new ColorMatrixFilter([0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0, 0, 0, 1, 0])];
			}
			else
			{
				maskMc.gotoAndStop(1);
				if (_sp) _sp.filters = null;
			}
		}
		 
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * 
		 */
		private function onBackBtnMouseOver(evt:MouseEvent):void
		{
			if (_params['mouseOver'] != null && _params['mouseOver'] is Function) _params['mouseOver'](_params);
			if(_isClick) return;
			maskMc.gotoAndStop(2);
			if (_sp) _sp.filters = [new ColorMatrixFilter([0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0, 0, 0, 1, 0])];
		}
		
		/**
		 * 
		 */
		private function onBackBtnMouseOut(evt:MouseEvent):void
		{
			if (_params['mouseOut'] != null && _params['mouseOut'] is Function) _params['mouseOut'](_params);
			if(_isClick) return;
			maskMc.gotoAndStop(1);
			if (_sp) _sp.filters = null;
		}
		
		/**
		 * load item complete
		 */
		private function onLoadItemComplete(params:Object):void
		{
			Clear.removeChild(preloader);
			
			_sp = new Sprite();
			var lo:Loader = params.data ;
			var newslide:SlideUtils = new SlideUtils( { sw:70, sh:70, effect:7,transition:"easeoutback", number:6,delay:1, mc:lo, link:"", target:"" } );
			//_sp.x = 5;
			//_sp.y = 35;
			_sp.mouseChildren = false;
			_sp.addChild(newslide);
			addChildAt(_sp, 0);
			
			changeState(_isClick);
		}
		
		/**
		 * load item error
		 */
		private function onLoadItemError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load item progress
		 */
		private function onLoadItemProgress(params:Object):void
		{
			
		}
		
		/**
		 *
		 */
		private function onItemMouseClick(evt:MouseEvent):void
		{
			if(_isClick) return;
			if (_params['clickFun'] != null && _params['clickFun'] is Function) _params['clickFun'](_params);
		}
		
	}
	
}