﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * GalleryMain
 *
 * @version 1
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.gallery
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.PageItemsUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	public class GalleryMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  xml data
		 */
		private var _config:String;
		private var _xml:XML;
		
		/**
		 * show width/height
		 */
		private var _sw:Number;
		private var _sh:Number;
		private var _changeFun:Function;
		
		private var _sx:Number = 38;
		private var _sy:Number = 510;
		private var _spacing:Number = 71;

		private var _hLen:int = 5;
		private var _vLen:int = 1;
		private var _changeLen:int = 1;
		
		private var _nowList:Array;

		private var nextBool:Boolean;
		
		private var _delay:Number = 0.8;
		
		private var _selectId:int = 0;
		
		/**
		 *  images array
		 */
		private var _itemArray:Array;
		private var _itemLength:int;
		
		private var _pageUtils:PageItemsUtils;
		private var _preBtn:NavPreBtn;
		private var _nextBtn:NavNextBtn;
		
		/**
		 * panel
		 */
		private var _imagePanel:GalleryImagePanel;
		private var _itemsPanel:Sprite;
		private var _tip:GalleryTipItem;
		
		/**
    	 *  constructor
     	 */
		public function GalleryMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			if (this.loaderInfo.parameters.xml != null)
			{
				_config = this.loaderInfo.parameters.xml || "";
			}
			else
			{
				_config = "xmlsetting/gallery_config.xml";
			}
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 * analyze XML data
		 */
		private function analyzeXML():void
		{
			//style
			_sw			= Number(_xml.style.width) || 430;
			_sh			= Number(_xml.style.height) || 600;
			
			//items
			_itemArray	= [];
			_itemLength = _xml.items.item.length();
			
			for (var i:int = 0; i < _itemLength;i++ )
			{
				var obj:Object = { };
				obj.id 		= i;
				obj.title	= _xml.items.item[i].@title;
				obj.src		= _xml.items.item[i].@src;
				obj.thumsrc = _xml.items.item[i].@thumscr;
				_itemArray.push(obj);
			}
			
			_imagePanel = new GalleryImagePanel();
			_imagePanel.x = 215;
			_imagePanel.y = 250;
			addChild(_imagePanel);
			
			_itemsPanel = new Sprite();
			_itemsPanel.x = _sx;
			_itemsPanel.y = _sy;
			addChild(_itemsPanel);
			
			var ms:Sprite = new Sprite();
			ms.graphics.beginFill(0x000000, 0);
			ms.graphics.drawRect(0,0,354, 70);
			ms.graphics.endFill();
			_itemsPanel.addChild(ms);
			
			_itemsPanel.mask = ms;
			
			_preBtn = new NavPreBtn();
			_preBtn.buttonMode = true;
			_preBtn.mouseChildren = false;
			//_preBtn.scaleX = 2;
			//_preBtn.scaleY = 2;
			_preBtn.x = 3;
			_preBtn.y = _sh  - 90;
			_preBtn.addEventListener(MouseEvent.CLICK, onNavBtnClick);
			addChild(_preBtn);
			
			_nextBtn = new NavNextBtn();
			_nextBtn.buttonMode = true;
			_nextBtn.mouseChildren = false;
			_nextBtn.x = _sw - 37;
			_nextBtn.y = _sh - 90;
			//_nextBtn.scaleX = 2;
			//_nextBtn.scaleY = 2;
			
			_nextBtn.addEventListener(MouseEvent.CLICK, onNavBtnClick);
			addChild(_nextBtn);
			
			_pageUtils = new PageItemsUtils(_hLen,_vLen,_changeLen, changeFun);
			_pageUtils.list = _itemArray;

		}
		
		/**
		 * change
		 */
		private function changeFun(bool:Boolean):void
		{
			setBtn(_preBtn, _pageUtils.prevcan);
			setBtn(_nextBtn, _pageUtils.nextcan);
			
			if (bool)
			{
				addNowList(_pageUtils.moveList);
				
				if (_pageUtils.moveList.length < _hLen)
				{
					_itemsPanel.x = (_sw - _itemsPanel.width) / 2;
				}
				itemClick(_pageUtils.moveList[0]);
			}
			else
			{
				if(nextBool)
				{
					for(var i:int=0; i<_nowList.length; i++)
					{
						if(i < _pageUtils.delList.length)
						{
							Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, x: _spacing * (i - _changeLen), alpha:0, onComplete:onComplete,onCompleteParams:[_nowList[i]] } );
						}
						else
						{
							Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, x: _spacing * (i - _changeLen)} );
						}
					}
					
					for each(var obj:* in _pageUtils.delList)
					{
						_nowList.shift();
					}
					
					for(var j:int = 0; j<_pageUtils.addList.length ; j++)
					{
						var item:GalleryItem = getItem(_pageUtils.addList[j]);
						item.x = _spacing * (j + _vLen*_hLen);
						_itemsPanel.addChild(item);
						_nowList.push(item);
						
						Tweener.addTween(item as DisplayObject, { time:_delay, x: _spacing * (j + _vLen*_hLen - _changeLen)} );
					}

				}
				else
				{
					changePre();
				}
			}
		}
		
		/**
		 *
		 */
		private function changePre():void
		{
			for(var i:int=0; i<_nowList.length; i++)
			{
				if(i >= _nowList.length - _pageUtils.delList.length)
				{
					Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, x: _spacing * (i + _changeLen), alpha:0, onComplete:onComplete,onCompleteParams:[_nowList[i]] } );
				}
				else
				{
					Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, x: _spacing * (i + _changeLen)} );
				}
			}
			
			for each(var obj:* in _pageUtils.delList)
			{
				_nowList.pop();
			}
			
			for(var j:int = _pageUtils.addList.length - 1; j>=0 ; j--)
			{
				var item:GalleryItem = getItem(_pageUtils.addList[j]);
				item.x = _spacing * (j - _pageUtils.addList.length);
				_itemsPanel.addChild(item);
				_nowList.unshift(item);
				
				Tweener.addTween(item as DisplayObject, { time:_delay, x: _spacing * j} );
			}
		}
		
		/**
		 *
		 */
		public function itemClick(params:*):void
		{
			_selectId = params.id;
			_imagePanel.changeImage(params.src);
			//trace(obj.id);
			for each(var obj:* in _nowList)
			{
				//trace(obj.id,params.id);
				if(obj != null && obj is GalleryItem)
				{
					obj.changeState(Boolean(obj.id == _selectId));
				}
			}
		}
		
		/**
		 * 
		 */
		public function itemOver(params:*):void
		{
			for each(var obj:* in _nowList)
			{
				//trace(obj.id,params.id);
				if (obj != null && obj is GalleryItem && obj.id == params.id)
				{
					itemOut(null);
					_tip = new GalleryTipItem(params.title);
					_tip.mouseEnabled = false;
					_tip.alpha = 0;
					addChild(_tip);
					_tip.x = 35 + obj.x + _sx;
					_tip.y = obj.y - 10 +_sy ;
					Tweener.addTween(_tip, { time:_delay,alpha:1} );
				}
			}
			
		}
		
		/**
		 * 
		 */
		public function itemOut(params:*):void
		{
			if (_tip)
			{
				Tweener.removeTweens(_tip);
				Clear.removeChild(_tip);
				_tip = null;
			}
		}
		
		/**
		 *
		 */
		private function onComplete(obj:*):void
		{
			Clear.removeChild(obj);
		}
		/**
		 * set button state
		 */
		private function setBtn(obj:*,bool:Boolean):void
		{
			if (bool)
			{
				obj.mouseEnabled = true;
				Tweener.addTween(obj, { alpha:1,time:_delay } );
			}
			else
			{
				obj.mouseEnabled = false;
				Tweener.addTween(obj, { alpha:0.5,time:_delay } );
			}
		}
		
		/**
		 * add items
		 */
		private function addNowList(arr:Array):void
		{
			_nowList = [];
			for (var i:int = 0; i < arr.length;i++ )
			{
				var item:GalleryItem = getItem(arr[i]);
				item.x = _spacing * i;
				_itemsPanel.addChild(item);
				_nowList.push(item);
			}
		}
		
		/**
		 * addItem
		 */
		private function getItem(data:Object):GalleryItem
		{
			data.clickFun 	= itemClick;
			data.mouseOver 	= itemOver;
			data.mouseOut	= itemOut;
			var item:GalleryItem = new GalleryItem(data, Boolean(_selectId == data.id));
			return item;
		}
		
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
			Clear.removeChild(preloader);
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * 
		 */
		private function onNavBtnClick(evt:MouseEvent):void
		{
			if (evt.currentTarget == _preBtn)
			{
				nextBool = false;
				_pageUtils.prev();
			}
			else
			{
				nextBool = true;
				_pageUtils.next();
			}
		}
	
	}
	
}