﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * ComTitleItem
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.home
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.*;
	import com.activetofocus.utils.Clear;
	import flash.filters.DropShadowFilter;
	
	public class ComTitleItem extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _params:Object;
		
		/**
		 * show width/height
		 */
		private var _width:Number;
		private var _height:Number;
		
		private var _content:Sprite;
		
		private var _mask:Sprite;
		
		private var _delay:Number = 0.6;
		
		/**
    	 *  constructor
     	 */
		public function ComTitleItem(params:Object) 
		{
			_params = params;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			textField.autoSize      	= TextFieldAutoSize.LEFT;
			textField.wordWrap       	= false;
			textField.mouseEnabled 		= false;
			textField.selectable 		= false;
			
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * init all data
		 */
		private function init():void
		{
			_content = new Sprite();
			addChildAt(_content,0);
			
			textField.htmlText = _params['title'];
			
			_width = textField.textWidth + 25;
			_height = textField.textHeight + 20;
			
			_content.graphics.beginFill(uint(_params['bgcolor']), Number(_params['bgalpha']));
			_content.graphics.drawRect(0, 0, _width, _height);
			_content.graphics.endFill();
		
			if (_params['shadow']) _content.filters = [new DropShadowFilter(5, 45, 0x000000, 0.4, 7, 7)];
			
			_mask = new Sprite();
			_mask.graphics.beginFill(0xff0000, 1);
			_mask.graphics.drawRect(-3, -3, _width + 6, _height + 6);
			_mask.graphics.endFill();
			addChild(_mask);
			_mask.scaleX = 0;
			this.mask = _mask;
			Tweener.addTween(_mask, { scaleX:1, time:_delay,transition:Equations.easeInCubic } );
		}
		
		/**
		 *  close title
		 */
		public function closeTitle():void
		{
			Tweener.removeTweens(_mask);
			Tweener.addTween(_mask, { scaleX:0, time:_delay,transition:Equations.easeInCubic,onComplete:onComplete} );
			//Tweener.addTween(this, {alpha:0,time:_delay ,onComplete:onComplete} );
		}
		
		/**
		 * remove title
		 */
		private function onComplete():void
		{
			Clear.removeChild(this);
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		
	}
	
}