﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * HomeMain
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
package com.activetofocus.facebook.modules.home
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.facebook.modules.home.ComTitleItem;
	import com.activetofocus.utils.DisplayLine;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.display.MovieClip;
	
	public class HomeMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  xml data
		 */
		private var _config:String;
		private var _xml:XML;
		
		/**
		 * state width/height
		 */
		private var _sw:Number = 430;
		private var _sh:Number = 600;
		private var _auto:Boolean;
		private var _delay:Number;
		
		private var _timer:Timer;
		
		/**
		 *  images array
		 */
		private var _itemArray:Array;
		private var _itemLength:int;
		
		private var _nowInt:int = 0;
		
		private var _maxInt:int = 0;
		
		private var _titleArray:Array;
		
		private var _slideArray:Array = [];
		
		private var _preBtn:NavPreBtn;
		private var _nextBtn:NavNextBtn;
		private var _pageInfo:BannerRotatorPage;
		
		/**
		 * panel
		 */
		private var _border:Sprite;
		private var _imgPanel:Sprite;
		private var _titlePanel:Sprite;
		private var _btnPanel:Sprite;
		
		private var _oldslide:SlideUtils;
		private var _newslide:SlideUtils;
		
		private var _countdown:CountDownPreloader;
		
		/**
    	 *  constructor
     	 */
		public function HomeMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			if (this.loaderInfo.parameters.xml != null)
			{
				_config = this.loaderInfo.parameters.xml || "";
			}
			else
			{
				_config = "xmlsetting/home_config.xml";
			}
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 * analyze XML data
		 */
		private function analyzeXML():void
		{
			//style
			_sw			= Number(_xml.style.width) || 430;
			_sh			= Number(_xml.style.height) || 600;
			_auto		= _xml.style.autoplay == "true";
			_delay		= _xml.style.delay || 3;
			
			//items
			_itemArray	= [];
			_itemLength = _xml.items.item.length();
			
			for (var i:int = 0; i < _itemLength;i++ )
			{
				var obj:Object = { };
				obj.src		= _xml.items.item[i].@src;
				obj.link 	= _xml.items.item[i].@link;
				obj.target	= _xml.items.item[i].@target;
				obj.effect 	= int(_xml.items.item[i].@effect) || 0;
				obj.transition = _xml.items.item[i].@transition || "easeoutcubic";
				obj.number 	= int(_xml.items.item[i].@number) || 10;
				obj.delay	= Number(_xml.items.item[i].@delay) || 1;
				obj.textArray = [];
				var k:int = _xml.items.item[i].text.length();
				for(var j:int=0;j<k;j++)
				{
					var t:Object = {};
					t.title 	= _xml.items.item[i].text[j];
					t.x			= _xml.items.item[i].text[j].@px;
					t.y			= _xml.items.item[i].text[j].@py;
					t.bgcolor	= _xml.items.item[i].text[j].@bgcolor;
					t.bgalpha	= _xml.items.item[i].text[j].@bgalpha;
					t.shadow	= _xml.items.item[i].text[j].@shadow == "true";
					obj.textArray.push(t);
				}
				_itemArray.push(obj);
			}
			
			_imgPanel = new Sprite();
			addChild(_imgPanel);
			
			_titlePanel = new Sprite();
			addChild(_titlePanel);
			
			
			
			if (_auto)
			{
				_countdown = new CountDownPreloader();
				_countdown.x = 10;
				_countdown.y = 10;
				_countdown.visible = false;
				addChild(_countdown);
			}
			
			_pageInfo = new BannerRotatorPage()
			_pageInfo.x = 0;
			_pageInfo.y = _sh - 145;
			addChild(_pageInfo);
			_pageInfo.page.selectable = false;
			
			addElement();
		}
		
		/**
		 *  add image items
		 */
		private function addElement():void
		{
			var qloader:Qloader = new Qloader({QloaderNumber:1,itemIOErrorFun:onLoadItemError,itemCompleteFun:onLoadItemComplete,itemProgressFun:onLoadItemProgress});
			for (var i:int = 0; i < _itemLength;i++ )
			{
				qloader.load(_itemArray[i].src,{id:i});
			}
			qloader.execute();
		}
		
		/**
		 * add buttons
		 */
		private function addButton(i:int):void
		{
			_itemArray[i].btn = true;
			if (i == 1)
			{
				_preBtn = new NavPreBtn();
				_preBtn.x = 0;
				_preBtn.y = _sh - 120;
				_preBtn.buttonMode = true;
				_preBtn.mouseChildren = false;
				_preBtn.addEventListener(MouseEvent.CLICK, onBtnMouseClick);
				_preBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnMouseOver);
				_preBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnMouseOut);
				addChild(_preBtn);
				
				_nextBtn = new NavNextBtn();
				_nextBtn.x = 0;
				_nextBtn.y = _sh - 79;
				_nextBtn.buttonMode = true;
				_nextBtn.mouseChildren = false;
				_nextBtn.addEventListener(MouseEvent.CLICK, onBtnMouseClick);
				_nextBtn.addEventListener(MouseEvent.MOUSE_OVER, onBtnMouseOver);
				_nextBtn.addEventListener(MouseEvent.MOUSE_OUT, onBtnMouseOut);
				addChild(_nextBtn);
			}
			
			_maxInt = (i + 1);
			
			_pageInfo.page.text = "0"+(_nowInt + 1)+"/0"+_maxInt;
		}
		
		/**
		 * show images
		 */
		private function showImage(i:int):void
		{
			if (_auto) closeTimer();
			_nowInt = i;
			closeTitle();
			if (_newslide) _newslide.close();
			
			_newslide = new SlideUtils({id:i,sw:_sw,sh:_sh,effect:_itemArray[i].effect,transition:_itemArray[i].transition,number:_itemArray[i].number,delay:_itemArray[i].delay,mc:_itemArray[i].mc,link:_itemArray[i].link,target:_itemArray[i].target,onComplete:onShowImageComplete})
			_imgPanel.addChild(_newslide);
			
			_slideArray.push(_newslide);
			
			//show page
			_pageInfo.page.text = "0"+(_nowInt + 1)+"/0"+_maxInt;
		}
		
		/**
		 * save current image
		 */
		private function onShowImageComplete(params:Object):void
		{
			if (_oldslide)
			{
				Clear.removeChild(_oldslide);
			}
			_oldslide = _newslide;
			var arr:Array = [];
			for each(var obj:* in _slideArray)
			{
				if (obj != _oldslide) 
				{
					Clear.removeChild(obj);
				}
			}
			_slideArray = [_oldslide];
			_newslide = null;
			showTitle(params.id);
			if (_auto) startTimer();
		}
		
		/**
		 * show titles
		 */
		private function showTitle(k:int):void
		{
			_titleArray = [];
			for(var i:int=0;i<_itemArray[k].textArray.length;i++)
			{
				var tItem:ComTitleItem = new ComTitleItem(_itemArray[k].textArray[i]);
			//	tItem.alpha = 0;
				tItem.x = _itemArray[k].textArray[i].x;
				tItem.y = _itemArray[k].textArray[i].y;
				
				//Tweener.addTween(tItem, {alpha:1,x:_itemArray[k].textArray[i].x,time:0.6,delay:0.3*i } );
				
				_titlePanel.addChild(tItem);
				_titleArray.push(tItem);
			}
		}
		
		/**
		 * remove titles
		 */
		private function closeTitle():void
		{
			if (!_titleArray || _titleArray.lenght == 0) return;
			for (var i:int = 0; i < _titleArray.length;i++ )
			{
				_titleArray[i].closeTitle();
			}
			_titleArray = null;
		}
		
		/**
		 * start autoplay
		 */
		private function startTimer():void
		{
			_countdown.gotoAndStop(1);
			_countdown.visible = true;
			var k:Number = Math.ceil((_delay * 1000) / 50);
			_timer = new Timer(k, 50);
			_timer.addEventListener(TimerEvent.TIMER, onChangeTimer);
			_timer.addEventListener(TimerEvent.TIMER_COMPLETE, onTimerComplete);
			_timer.start();
		}
		
		/**
		 * close timer
		 */
		private function closeTimer():void
		{
			_countdown.gotoAndStop(1);
			_countdown.visible = false;
			if (_timer) _timer.stop();
			Clear.removeEvent(_timer, TimerEvent.TIMER, onChangeTimer);
			Clear.removeEvent(_timer, TimerEvent.TIMER_COMPLETE, onTimerComplete);
			_timer = null;
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * load item complete
		 */
		private function onLoadItemComplete(params:Object):void
		{
			var k:int = params.params.id;
			_itemArray[k].mc = params.data;
			addButton(k);
			if (k == 0)
			{
				showImage(0);
				Clear.removeChild(preloader);
			}
		}
		
		/**
		 * load item error
		 */
		private function onLoadItemError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load item progress
		 */
		private function onLoadItemProgress(params:Object):void
		{
			
		}
		
		/**
		 * page button click effect
		 */
		private function onBtnMouseClick(evt:MouseEvent):void
		{
			if (evt.currentTarget == _preBtn)
			{
				if (_nowInt > 0)
				{
					showImage(int(_nowInt-1));
				}
				else
				{
					var i:int = _itemLength - 1;
					for (; i >= 0;i-- )
					{
						if (_itemArray[i].btn != null && _itemArray[i].btn == true)
						{
							break;
						}
					}
					showImage(i);
				}
				return;
			}
			if (evt.currentTarget == _nextBtn)
			{
				if (_nowInt >= _itemLength - 1)
				{
					showImage(0);
				}
				else
				{
					if (_itemArray[_nowInt+1].btn != null && _itemArray[_nowInt+1].btn == true)
					{
						showImage(_nowInt+1);
					}
					else
					{
						showImage(0);
					}
				}
				return;
			}
			if(_nowInt == int(evt.currentTarget.name)) return;
			showImage(int(evt.currentTarget.name));
		}
		
		/**
		 * page button mouse over effect
		 */
		private function onBtnMouseOver(evt:MouseEvent):void
		{
			if (evt.currentTarget == _preBtn || evt.currentTarget == _nextBtn)
			{
				evt.currentTarget.gotoAndStop(2);
				return;
			}
			if(_nowInt == int(evt.currentTarget.name)) return;
			evt.currentTarget.gotoAndStop(2);
		}
		
		/**
		 * page button mouse out effect
		 */
		private function onBtnMouseOut(evt:MouseEvent):void
		{
			if (evt.currentTarget == _preBtn || evt.currentTarget == _nextBtn)
			{
				evt.currentTarget.gotoAndStop(1);
				return;
			}
			if(_nowInt == int(evt.currentTarget.name)) return;
			evt.currentTarget.gotoAndStop(1);
		}
		
		/**
		 * timer change
		 */
		private function onChangeTimer(evt:TimerEvent):void
		{
			_countdown.gotoAndStop(_timer.currentCount);
		}
		
		/**
		 * timer complete
		 */
		private function onTimerComplete(evt:TimerEvent):void
		{
			closeTimer();
			if (_nowInt + 1 < _itemArray.length && _itemArray[_nowInt + 1].btn != null)
			{
				showImage(_nowInt + 1);
			}
			else 
			{
				if (_nowInt == 0)
				{
					startTimer();
				}
				else
				{
					showImage(0);
				}
			}
			//next image
		}
	}
	
}