﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * ComServicesItem
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.services
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.PageUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.TextUtils;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.text.*;
	import com.activetofocus.utils.Clear;
	import flash.filters.DropShadowFilter;
	
	public class ComServicesItem extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _params:Object;
		private var _delay:Number = 0.6;
		
		private var _textUtils:TextUtils;
		
		private var _sp:Sprite;
		
		/**
		 * panel
		 */
		
		
		/**
    	 *  constructor
     	 */
		public function ComServicesItem(params:Object=null) 
		{
			_params = params;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		public function get id():int
		{
			return _params['id']
		}
		
		public function close():void
		{
			if (_textUtils) _textUtils.visible = false;
		}
		
		/**
		 * init all data
		 */
		private function init():void
		{
			maskMc.blendMode = "layer";
			maskMc.alpha = .7;
			titleTxt.text = _params['title'];
			
			//this.mouseChildren = false;
			//this.buttonMode = true;
			
			this.addEventListener(MouseEvent.MOUSE_OVER, onBackBtnMouseOver);
			this.addEventListener(MouseEvent.MOUSE_OUT, onBackBtnMouseOut);

			_textUtils = new TextUtils();
			_textUtils.x = 158;
			_textUtils.y = 38;
			_textUtils.width = 240;
			_textUtils.height = 130;
			_textUtils.scrollbordercolor = 0xffffff;
			_textUtils.scrollcolor = 0xffffff;
			_textUtils.useBackground = true;
			_textUtils.scrolllinecolor = 0x0A0A0A;
			_textUtils.scrollalpha = 0.6;
			_textUtils.htmlText = _params['desc'];
			addChild(_textUtils);
			
			//descTxt.htmlText = _params['desc'];
			
			var qloader:Qloader = new Qloader({QloaderNumber:1,itemIOErrorFun:onLoadItemError,itemCompleteFun:onLoadItemComplete,itemProgressFun:onLoadItemProgress});
			qloader.load(_params['src']);
			qloader.execute();
			
		}
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * 
		 */
		private function onBackBtnMouseOver(evt:MouseEvent):void
		{
			Tweener.addTween(maskMc, { alpha:1, time:_delay } );
			if (_sp) _sp.filters = [new ColorMatrixFilter([0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0.3086, 0.6094, 0.082, 0, 0, 0, 0, 0, 1, 0])];
		}
		
		/**
		 * 
		 */
		private function onBackBtnMouseOut(evt:MouseEvent):void
		{
			Tweener.addTween(maskMc, { alpha:.7, time:_delay } );
			if (_sp) _sp.filters = null;
		}
		
		/**
		 * load item complete
		 */
		private function onLoadItemComplete(params:Object):void
		{
			Clear.removeChild(preloader);
			_sp = new Sprite();
			var lo:Loader = params.data ;
			var newslide:SlideUtils = new SlideUtils( { sw:150, sh:170, effect:5,transition:"easeoutback", number:5,delay:0.8, mc:lo, link:"", target:"" } );
			_sp.x = 0;
			_sp.y = 0;
			_sp.mouseChildren = false;
			_sp.addChild(newslide);
			addChildAt(_sp, 0);
		}
		
		/**
		 * load item error
		 */
		private function onLoadItemError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load item progress
		 */
		private function onLoadItemProgress(params:Object):void
		{
			//Tweener.addTween(_progSprite, {width:280 * Number(params.bytesLoaded/params.bytesLoaded),time:0.3 ,transition:"linear"} );
		}
		
	}
	
}