﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * ServicesMain
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.facebook.modules.services
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.PageUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.SlideUtils;
	import com.activetofocus.utils.DisplayLine;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	public class ServicesMain extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  xml data
		 */
		private var _config:String;
		private var _xml:XML;
		
		/**
		 * state width/height
		 */
		private var _sw:Number = 430;
		private var _sh:Number = 600;
		
		private var _spacing:Number = 180;
		
		private var _pageMax:int = 3;
		
		private var _nowList:Array;
		
		private var bool:Boolean;
		
		private var nextBool:Boolean;
		
		private var _delay:Number = 0.8;
		
		/**
		 *  images array
		 */
		private var _itemArray:Array;
		private var _itemLength:int;
		
		private var _pageUtils:PageUtils;
		private var _preBtn:ComServicesNavBtn;
		private var _nextBtn:ComServicesNavBtn;
		
		/**
		 * panel
		 */
		private var _contentPanel:Sprite;
		
		/**
    	 *  constructor
     	 */
		public function ServicesMain() 
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			loadMainXML();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load main XML files
		 */
		private function loadMainXML():void
		{
			if (this.loaderInfo.parameters.xml != null)
			{
				_config = this.loaderInfo.parameters.xml || "";
			}
			else
			{
				_config = "xmlsetting/services_config.xml";
			}
			/*  publish use the cache ,keep all xml is newest */
			//var qloader:QloaderItem = Qloader.load(_config + "?cache" + new Date().getTime());
			
			var qloader:Qloader = new Qloader({itemIOErrorFun:onLoadMainXMLError,itemCompleteFun:onLoadMainXMLComplete,itemProgressFun:onLoadMainXMLProgress});
			qloader.load(_config);
			qloader.execute();
		}
		
		/**
		 * analyze XML data
		 */
		private function analyzeXML():void
		{
			//style
			_sw			= Number(_xml.style.width) || 430;
			_sh			= Number(_xml.style.height) || 600;
			
			//items
			_itemArray	= [];
			_itemLength = _xml.items.item.length();
			
			for (var i:int = 0; i < _itemLength;i++ )
			{
				var obj:Object = { };
				obj.title	= _xml.items.item[i].@title;
				obj.date	= _xml.items.item[i].@date;
				obj.src		= _xml.items.item[i].@src;
				obj.desc 	= _xml.items.item[i];
				_itemArray.push(obj);
			}
			
			_contentPanel = new Sprite();
			_contentPanel.x = 5;
			_contentPanel.y = 5;
			addChild(_contentPanel);

			_preBtn = new ComServicesNavBtn();
			_preBtn.buttonMode = true;
			_preBtn.mouseChildren = false;
			_preBtn.x = 40;
			_preBtn.y = _sh - 35;
			_preBtn.addEventListener(MouseEvent.CLICK, onNavBtnClick);
			addChild(_preBtn);
			
			_nextBtn = new ComServicesNavBtn();
			_nextBtn.buttonMode = true;
			_nextBtn.mouseChildren = false;
			_nextBtn.x = 101;
			_nextBtn.y = _sh - 35;
			_nextBtn.rotation = 180;
			_nextBtn.addEventListener(MouseEvent.CLICK, onNavBtnClick);
			addChild(_nextBtn);
			
			_pageUtils = new PageUtils(1,changeFun);
			_pageUtils.page = (_itemArray.length > _pageMax) ?  (_pageMax - 1) : _itemArray.length;
			_pageUtils.list = _itemArray;
			
			var ms:Sprite = new Sprite();
			ms.graphics.beginFill(0xff0000, 1);
			ms.graphics.drawRect(0, 5, _sw, _spacing * 3 - 5);
			ms.graphics.endFill();
			_contentPanel.addChild(ms);
			_contentPanel.mask = ms;
		}
		
		/**
		 * change
		 */
		private function changeFun():void
		{
			if (_pageUtils.page > _pageMax - 1)
			{
				setBtn(_preBtn, true);
			}
			else
			{
				setBtn(_preBtn, false);
			}
			if (_pageUtils.nextcan)
			{
				setBtn(_nextBtn, true);		
			}
			else
			{
				setBtn(_nextBtn, false);		
			}
			
			if (bool)
			{
				if (nextBool)
				{
					moveNowList(_pageUtils.currectlist[0]);
				}
				else
				{
					var k:int = _pageUtils.page - _pageMax + 1;
					moveNowList(_itemArray[k]);
				}
				
			}
			else
			{
				bool = true;
				addNowList(_itemArray);
			}
		}
		
		/**
		 * set button state
		 */
		private function setBtn(obj:*,bool:Boolean):void
		{
			if (bool)
			{
				obj.mouseEnabled = true;
				Tweener.addTween(obj, { alpha:1,time:_delay } );
			}
			else
			{
				obj.mouseEnabled = false;
				Tweener.addTween(obj, { alpha:0.5,time:_delay } );
			}
		}
		
		/**
		 * add items
		 */
		private function addNowList(arr:Array):void
		{
			_nowList = [];
			for (var i:int = 0; i < arr.length && i< _pageMax;i++ )
			{
				var item:ComServicesItem = getItem(arr[i]);
				item.y = _spacing * i + 5;
				item.x = 5;
				_contentPanel.addChild(item);
				_nowList.push(item);
			}
		}
		
		/**
		 * move list
		 */
		private function moveNowList(data:Object):void
		{
			var k:int;
			var item:ComServicesItem = getItem(data);
			item.alpha = 0;
			_contentPanel.addChild(item);
			if (nextBool)
			{
				item.x = 5;
				item.y = _spacing * _pageMax + 5;
				_nowList.push(item);
				k = 0;
			}
			else
			{
				item.x = 5;
				item.y = -_spacing + 5;
				_nowList.unshift(item);
				k = (_nowList.length - 1);
			}
			
			for(var i:int =0 ;i<_nowList.length;i++)
			{
				if(i==k)
				{
					if (nextBool)
					{
						Tweener.addTween(_nowList[k] as DisplayObject, { time:_delay, y: -_spacing +5, onComplete:onComplete,onCompleteParams:[_nowList[k]] } );
					}
					else
					{
						Tweener.addTween(_nowList[k] as DisplayObject, { time:_delay, y: (k) * _spacing +5, onComplete:onComplete,onCompleteParams:[_nowList[k]] } );
					}
					_nowList[k].close();
				}
				else
				{
					if (nextBool)
					{
						Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, y: (i - 1 ) * _spacing + 5, alpha:1 } );
					}
					else
					{
						Tweener.addTween(_nowList[i] as DisplayObject, { time:_delay, y: (i) * _spacing + 5, alpha:1 } );
					}
				}
			}
			
			if (nextBool)
			{
				_nowList.shift();
			}
			else
			{
				_nowList.pop();
			}
			
			function onComplete(obj:*):void
			{
				Clear.removeChild(obj);
			}
		}
		
		/**
		 * addItem
		 */
		private function getItem(data:Object):ComServicesItem
		{
			var item:ComServicesItem = new ComServicesItem(data);
			return item;
		}
		
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * load XML complete
		 */
		private function onLoadMainXMLComplete(params:Object):void
		{
			_xml = new XML(params.data);
			analyzeXML();
		}
		
		/**
		 * load XML error
		 */
		private function onLoadMainXMLError(params:Object):void
		{
			trace("onLoadMainXMLError");
		}
		
		/**
		 * load XML progress
		 */
		private function onLoadMainXMLProgress(params:Object):void
		{
			
		}
		
		/**
		 * 
		 */
		private function onNavBtnClick(evt:MouseEvent):void
		{
			if (evt.currentTarget == _preBtn)
			{
				nextBool = false;
				_pageUtils.prev();
			}
			else
			{
				nextBool = true;
				_pageUtils.next();
			}
		}
	
	}
	
}