﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BackgroundPanel
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.view
{
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.facebook.view.BackgroundPanelItem;
	import flash.display.*;
	
	public class BackgroundPanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  STYLE
		 */
		private var _delay:Number;
		private var _switchDelay:Number;
		private var _effect:int;
		
		/**
		 * background url
		 */
		private var _url:String;
		
		private var _lastObj:BackgroundPanelItem;
		private var _nowObj:BackgroundPanelItem;
		
		private var _loadBool:Boolean;
		
		/**
		 * _style  
		 * <background alpha="0.35" time="1" delay="0" effect="1" mask="false" default="assets/background/bg1.jpg" />
		 */
		private var _style:Object =
				{
					alpha:1,
					time:1,
					delay:0,
					effect:1,
					mask:false
				};
		
		/**
		 * _params
		 * onStart
		 * onComplete
		 * onIOError
		 * onProgress
		 */
		private var _params:Object = 
				{
					onStart:null,
					onComplete:null,
					onIOError:null,
					onProgress:null
				}
		
		/**
    	 *  constructor
     	 */
		public function BackgroundPanel(style:Object,params:Object) 
		{
			_delay								= style.delay || 0.4;
			_switchDelay					 	= style.switchdelay || 0;
			_effect								= style.effect || 0;
			trace(_effect);
			_style  = ObjectUtils.updateParams(_style, style);
			_params = ObjectUtils.updateParams(_params, params);
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{

		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * change background
		 */
		public function changeBackground(url:String):void
		{
			//trace(_url,url,_loadBool);
			if (_url == url) return;
			_url  = url;
			if (_loadBool) _nowObj.close();
			load();
		}
		
		/**
		 * load background
		 */
		private function load():void
		{
			_loadBool = true;
			_nowObj = new BackgroundPanelItem( _style,{onStart:onStart,onIOError:onIOError,onProgress:onProgress,onComplete:onComplete } );
			_nowObj.load(_url);
		}
		
		/**
		 * load start
		 */
		private function onStart(params:*):void
		{
			if (_params && _params['onStart'] != null && _params['onStart'] is Function) _params['onStart'](params);
		}
		
		/**
		 * load ioerror
		 */
		private function onIOError(params:*):void
		{
			if (_params && _params['onIOError'] != null && _params['onIOError'] is Function) _params['onIOError'](params);
		}
		
		/**
		 * load progress
		 */
		private function onProgress(params:*):void
		{
			if (_params && _params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * load complete
		 */
		private function onComplete(params:*):void
		{
			addChild(_nowObj);
			_loadBool = false;
			_nowObj.blendMode = "layer";
			if (_lastObj) 
			{
				var k:int = (_effect == 0) ? Math.ceil(Math.random() * 16 + 1) : _effect;
				var _mask:Sprite;

				if (k == 1)
				{
					_nowObj.y = -this.stage.stageHeight;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,y:0,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 2)
				{
					_nowObj.y = this.stage.stageHeight;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,y:0,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 3)
				{
					_nowObj.x = -this.stage.stageWidth
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,x:0,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 4)
				{
					_nowObj.x = this.stage.stageWidth;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,x:0,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 5)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 6)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 7)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 8)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 9)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 10)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 11)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect11(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 12)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect12(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 13)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect13(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else 
				if (k == 14)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect14(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj] });
				}
				else
				{

					_nowObj.alpha = 0.1;
					Tweener.addTween(_nowObj, { time:_delay, delay:_switchDelay, alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj]  } );
				}
			}
			else
			{
				_nowObj.alpha = 0.1;
				Tweener.addTween(_nowObj,{time:_delay,alpha:1});
			}
			_lastObj = _nowObj;
			_nowObj = null;
			if (_params && _params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete'](null);
		}
		
		private function addEffect11(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(i*j+j)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		/**
		 *  add effect 12
		 */
		private function addEffect12(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			var k3:int = 0;
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(k3++)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		private function addEffect13(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			var k3:int = 0;
			for (var j:int = 0; j < k2;j++ )
			{
				for (var i:int = 0; i < k1;i++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(k3++)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		private function addEffect14(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 50);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawCircle(0,0,60);
					sp.graphics.endFill();
					
					sp.x = i * 50 + 50;
					sp.y = j * 50 + 25;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay, delay:0,transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		/**
		 * remove old element
		 */
		private function removeMaskOldElement(obj:*):void
		{
			Clear.removeChild(obj);
		}
	}
	
}