﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BackgroundPanelItem
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.view
{
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.DisplayLine;
	import flash.display.Sprite;
	
	public class BackgroundPanelItem extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * loader
		 */
		private var _qloader:Qloader;
		 
		/**
		 * _style  
		 * <background alpha="0.35" time="1" delay="0" effect="1" mask="false" default="assets/background/bg1.jpg" />
		 */
		private var _style:Object =
				{
					alpha:1,
					time:1,
					delay:0,
					effect:1,
					mask:false
				};
		
		/**
		 * _params
		 * onStart
		 * onComplete
		 * onIOError
		 * onProgress
		 */
		private var _params:Object = 
				{
					onStart:null,
					onComplete:null,
					onIOError:null,
					onProgress:null
				}
				
		/**
    	 *  constructor
     	 */
		public function BackgroundPanelItem(style:Object,params:Object) 
		{
			_style  = ObjectUtils.updateParams(_style, style);
			_params = ObjectUtils.updateParams(_params, params);
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{

		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * change background
		 */
		public function load(url:String):void
		{
			_qloader = new Qloader({itemIOErrorFun:onLoaderImageErrorEvent,itemCompleteFun:onLoaderImageCompleteEvent,itemProgressFun:onProgressEvent});
			_qloader.load(url);
			_qloader.execute();
			if (_params && _params['onStart'] != null && _params['onStart'] is Function) _params['onStart'](null);
		}
		
		/**
		 * 
		 */
		public function close():void
		{
			if(_qloader) _qloader.removeAll();
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader image error
		 */
		private function onLoaderImageErrorEvent(params:Object):void
		{
			trace("onLoaderImageErrorEvent");
		}
		
		/**
		 * load progress event
		 */
		private function onProgressEvent(params:Object):void
		{
			if (_params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * loader complete
		 */
		private function onLoaderImageCompleteEvent(params:Object):void 
		{
			//trace("onLoaderImageCompleteEvent");
			params.data.alpha = Number(_style['alpha']);
			addChild(params.data);
			_qloader = null;
			if (_style['mask'])
			{
				var line:Sprite = DisplayLine.getGird(520, 600, new GirdBitmapData(4,4));
				line.alpha = 0.8;
				addChild(line);
			}
			
			if (_params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete'](params);
		}
		 
	}
	
}