﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BottomPanel
 *
 * @version 1.0
 * @since  2011-07-30
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.view
{
	import caurina.transitions.Tweener;
	import com.activetofocus.facebook.components.SocialIcons;
	import com.activetofocus.facebook.components.ComMusicPlayerComponent;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import com.activetofocus.utils.Clear;
	import flash.text.TextField;
	import flash.events.TextEvent;
	import com.activetofocus.utils.LogoUtils;
	
	public class BottomPanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		private var _xml:XML;
		
		private var _style:Object =
						{
							align:"right",
							x:0,
							y:0,
							height:22,
							spacing:8,
							bgcolor:0x000000,
							bgalpha:1,
							fontsize:14,
							textdefaultcolor:0xffffff,
							textselectcolor:0x0e7aae,
							textovercolor:0x0e7aae
						};
						
						
		private var _logoUtils:LogoUtils;
		
		/**
		 * social
		 */
		private var _social:SocialIcons;
		
		/**
		 * music player
		 */
		private var _music:ComMusicPlayerComponent;
		
		/**
    	 *  constructor
     	 */
		public function BottomPanel(xml:XML) 
		{
			_xml = xml;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * init
		 */
		private function init():void
		{
			draw();
			addLogo();
			addMusicPlayer();
			addSocial();
			
			infoTxt.addEventListener(TextEvent.LINK, onInfoLink);
			infoTxt.htmlText = _xml.style.siteinfo || "";
			infoTxt.x = -430;
			infoTxt.y = 585;
		}
		
		/**
		 * add logo
		 */
		private function addLogo():void
		{
			_logoUtils = new LogoUtils( { src:_xml.style.logo.@src } );
			_logoUtils.x = Number(_xml.style.logo.@x);
			_logoUtils.y = Number(_xml.style.logo.@y);
			addChild(_logoUtils);
		}
		
		/**
		 * music player
		 */
		private function addMusicPlayer():void
		{
			_music = new ComMusicPlayerComponent(_xml.style.mp3.@path,(_xml.style.mp3.@auto == "true"));
			addChild(_music);
			
			_music.x = (90 - _music.width) - 5;
			_music.y = 600 - 40;
		}
		/**
		 * draw background
		 */
		private function draw():void
		{
			this.graphics.clear();
			this.graphics.beginFill(uint(_style['bgcolor']),Number(_style['bgalpha']));
			this.graphics.drawRect(0, 0, 90,600);
			this.graphics.endFill();
		}
		
		/**
		 * add social
		 */
		private function addSocial():void
		{
			_social = new SocialIcons(_xml.style.social);
			addChild(_social);
			
			_social.x = (90 - _social.width)/2;
			_social.y = 600 - _social.height - 5;
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * text link
		 */
		private function onInfoLink(evt:TextEvent):void
		{
			GetURL.open(evt.text);
		}
	}
	
}