﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * CenterPanel
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */


package com.activetofocus.facebook.view
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.Clear;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.Qloader;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	
	public class CenterPanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		private var _effectType:int = 0;//effect type
		
		private var _position:String = "center";
		
		private var _ewidth:Number;// element width
		
		private var _eheight:Number;// element height
		
		private var _path:String;// element path
		
		private var _delay:Number = 1.2;// effect delay time

		private var _nowObject:*;
		
		private var _oldObject:*;
		
		private var _newSrc:String;
		
		private var _newposition:String;
		
		private var _neweffectType:int;
		
		private var _needDelay:Boolean = true;
		
		private var _tweenObj:*;
		
		/**
		 *  all panel
		 */
		private var _mcPanel:Sprite;
		
		private var _qloader:Qloader;
		
		/**
		 * _params  Function
		 * onStart
		 * onComplete
		 * onIOError
		 * onProgress
		 */
		private var _params:Object =
				{
					onStart:null,
					onComplete:null,
					onIOError:null,
					onProgress:null,
					onChangeBackground:null
				};
		/**
    	 *  constructor
     	 */
		public function CenterPanel(params:Object) 
		{
			_params = params;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{		
			_mcPanel = new Sprite();
			_mcPanel.x = 430 / 2;
			_mcPanel.y = 600 / 2;
			addChild(_mcPanel);
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *  change image
		 */
		public function changeModule(url:String,w:Number,h:Number,position:String,effect:int,needdelay:Boolean):void
		{
			_newSrc = url;

			_ewidth  = w;
			_eheight = h;
			_needDelay = needdelay;
			_newposition = position;
			_neweffectType = effect;
					
			if (_qloader)
			{
				_qloader.removeAll();
				_qloader = null;
			}
			
			_qloader = new Qloader({itemIOErrorFun:onLoaderImageErrorEvent,itemCompleteFun:onLoaderImageCompleteEvent,itemProgressFun:onProgressEvent});
			_qloader.load(url);
			
			if(_nowObject)
			{
				if (_tweenObj == null || _tweenObj != _nowObject)
				{
					_tweenObj = _nowObject;
					Tweener.addTween(_tweenObj, { time:_delay, x: -645, transition:Equations.easeInOutCubic, onComplete:onDeleteComplete,onCompleteParams:[_tweenObj] } );
				}
			}
			else
			{
				if (_params['onStart'] != null && _params['onStart'] is Function) _params['onStart']();
				_qloader.execute();
			}
		}
		
		/**
		 * tween complete
		 */
		
		private function onDeleteComplete(obj:*):void
		{
			Clear.removeChild(obj);
			_nowObject = null;
			if (_qloader)
			{
				if (_params['onStart'] != null && _params['onStart'] is Function) _params['onStart']();
				_qloader.execute();
			}
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader image error
		 */
		private function onLoaderImageErrorEvent(params:Object = null):void
		{
			if (_params['onIOError'] != null && _params['onIOError'] is Function) _params['onIOError'](params);
		}
		
		/**
		 *  loader image complete
		 */
		private function onLoaderImageCompleteEvent(params:Object = null):void
		{
			if (_params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete']({src:_newSrc});
			
			_effectType = _neweffectType;
			
			var sp:Sprite = new Sprite();
			var lo:Loader = params.data as Loader;
			sp.addChild(lo);
			
			sp.x = 215;
			sp.y = -_eheight/2;
			
			Tweener.addTween(sp, { time:_delay , x:-_ewidth/2 ,delay: (_needDelay ? 0.5 : 0),onComplete:onComplete } );
			
			_mcPanel.addChild(sp);
			
			_nowObject = sp;
			_qloader = null;
			
		}
		
		/**
		 * progress event
		 */
		private function onProgressEvent(params:Object = null):void
		{
			if (_params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * 
		 */
		private function onComplete():void
		{
			if (_params['onChangeBackground'] != null && _params['onChangeBackground'] is Function) _params['onChangeBackground']();
		}
		
		
	}
	
}