﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * MenuPanel
 *
 * @version 1.0
 * @since  2011-07-29
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package  com.activetofocus.facebook.view
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import com.activetofocus.facebook.components.MenuItem;
	import com.activetofocus.facebook.components.SocialIcons;
	import com.activetofocus.utils.GetURL;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import com.activetofocus.utils.Clear;
	import flash.text.TextField;
	import flash.events.TextEvent;
	
	public class MenuPanel extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * data
		 */
		private var _menus:Array;
		
		private var _menuItems:Array;
		
		/**
		 * style
		 * <menus height="22" spacing="8" bgcolor="0x000000" bgalpha="1" fontsize="14" textdefaultcolor="0xffffff" textselectcolor="0x0e7aae" 
textovercolor="0x0e7aae">
		 */
		private var _style:Object =
						{
							x:0,
							y:0,
							height:22,
							spacing:8,
							bgcolor:0x000000,
							bgalpha:1,
							fontsize:14,
							textdefaultcolor:0xffffff,
							textselectcolor:0x0e7aae,
							textovercolor:0x0e7aae
						};
		
		private var _menuClickFun:Function;
		private var _completeFun:Function;
		
		/**
    	 *  constructor
     	 */
		public function MenuPanel(menus:Array,style:Object,completeFun:Function,menuClickFun:Function) 
		{
			_menus 			= menus;
			_style			= ObjectUtils.updateParams(_style, style);
			_completeFun	= completeFun;
			_menuClickFun 	= menuClickFun;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * change menu
		 */
		public function changeMenu(id:int):void
		{
			//trace("change",id);
			for (var i:int = 0; i < _menuItems.length;i++ )
			{
				_menuItems[i].changeState((i == id));
			}
		}
		
		/**
		 * init
		 */
		private function init():void
		{
			addMenus();
			
		}
		
		/**
		 * add menus
		 */
		private function addMenus():void
		{
			_menuItems = [];
			
			var spacing:Number = Number(_style['spacing']);
			//trace("add menus",spacing);
			for (var i:int = 0; i < _menus.length; i++ )
			{
				var menu:MenuItem = new MenuItem();
				menu.initData(i,_menus[i].title,_style,menuClick);
				addChild(menu);
				
				_menuItems.push(menu);
				menu.x = 110;
				menu.y = i * ( 24 + spacing);
				
				Tweener.addTween(menu, { time:0.4, transition:Equations.easeInOutCubic,x:0,delay:i*0.2} );
			}
			
			Tweener.addTween(this, { time:1,alpha:1,onComplete:onComplete} );
		}		
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * show complete
		 */
		private function onComplete():void
		{
			if (_completeFun != null) _completeFun();
		}
		
		/**
		 * menu click
		 */
		private function menuClick(params:*):void
		{
			if (_menuClickFun != null) _menuClickFun(params);
		}
	}
	
}