﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BackgroundUtils
 *
 * @version 1.0
 * @since  2010-06-24
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
	
package com.activetofocus.utils
{
	import com.activetofocus.utils.*;
	import flash.display.Sprite;
	import flash.events.IOErrorEvent;
	import flash.display.MovieClip;
    import flash.events.Event;
	import flash.events.ProgressEvent;
    import flash.net.URLLoader;
	import flash.net.URLRequest;
	import com.activetofocus.events.LoadDataEvent;
	import caurina.transitions.Tweener;
	
	public class BackgroundUtils extends Sprite
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * BACKGROUND ALL STYLE
		 */
		public static var STAGE_ALIGN:String;
		public static var VIDEO_BUFFER_TIME:Number;
		public static var VIDEO_TIME_PLAY:Number;
		public static var VIDEO_VOLUME:Number;
		/**
		 *  STYLE
		 */
		private var _delay:Number;
		private var _switchDelay:Number;
		private var _effect:int;
		/**
		 * DATA
		 */
		private var _url:String;
		private var _type:String;
		
		/**
		 * _params  Function
		 * onStart
		 * onComplete
		 * onIOError
		 * onProgress
		 */
		private var _params:Object =
				{
					onStart:null,
					onComplete:null,
					onIOError:null,
					onProgress:null
				};
		
		/**
		 * ALL ELEMENT
		 */
		private var _lastObj:*;
		private var _nowObj:*;
		
		private var _bgline:Sprite;
		
		/**
    	 *  constructor
     	 */
		public function BackgroundUtils(data:Object,params:Object = null):void
		{
			_delay								= data.delay || 0.4;
			_switchDelay					 	= data.switchdelay || 0;
			_effect								= data.effect || 0;
			BackgroundUtils.STAGE_ALIGN			= data.stagealign || "center";
			BackgroundUtils.VIDEO_BUFFER_TIME	= data.videobuffertime || 0.1;
			BackgroundUtils.VIDEO_TIME_PLAY		= data.videotimeplay || 0;
			BackgroundUtils.VIDEO_VOLUME		= data.videovolume || 1;
			
			_params 							= params;
		}
		
		/**
		 * change background
		 */
		public function changeBackground(url:String,style:Object = null):void
		{
			if (_url == url) return;
			_url  = url;
			if (url.indexOf(".swf") != -1 || url.indexOf(".jpg") != -1 || url.indexOf(".png") != -1 || url.indexOf(".gif") != -1 )
			{
				_type = "imageswf";
			}
			else if(_url.indexOf(".flv") != -1)
			{
				_type = "video";
			}
			else
			{
				//trace("data type error");
				return;
			}

			if (_nowObj)
			{
				_nowObj.close();
				_nowObj = null;
			}
			
			if (style == null)
			{
				style = { };
				style.stagealign 		= BackgroundUtils.STAGE_ALIGN;
				if (_type == "video")
				{
					style.videobuffertime 	= BackgroundUtils.VIDEO_BUFFER_TIME;
					style.videotimeplay 	= BackgroundUtils.VIDEO_TIME_PLAY
					style.videovolume 		= BackgroundUtils.VIDEO_VOLUME
				}
			}
			
			startBg(style);
		}
		
		/**
		 * close
		 */
		public function closeBackground():void
		{
			if (_nowObj)
			{
				trace("hide1");
				Tweener.addTween(_nowObj, { alpha:0,time:_delay } );
			}
			if (_lastObj)
			{
				trace("hide2");
				Tweener.addTween(_lastObj, { alpha:0,time:_delay } );
			}
		}
		
		/**
		 * start background load
		 */
		private function startBg(style:Object):void
		{
			if (_type == "imageswf") 
			{
				_nowObj = new BgImageSwf(this.stage,{onProgress:onProgressEvent,onComplete:onLoaderImageCompleteEvent});
			}
			else if(_type == "video")
			{ 
				_nowObj = new BgVideo(this.stage,{onProgress:onProgressEvent,onComplete:onLoaderImageCompleteEvent});
			}
			
			if (_params && _params['onStart'] != null && _params['onStart'] is Function) _params['onStart']();
			
			_nowObj.load(_url,style);
		}
		
		/**
		 * remove old element
		 */
		private function removeOldElement(obj:*):void
		{
			Clear.removeChild(obj);
		}
		
		/**
		 * 
		 */
		private function removeMaskOldElement(obj:*,mobj:*,newobj:*):void
		{
			Clear.removeChild(obj);
			Clear.removeChild(mobj);
			newobj.mask = null;
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  add element complete
		 */
		private function onLoaderImageCompleteEvent(params:Object = null):void 
		{
			addChild(_nowObj);
			_nowObj.blendMode = "layer";
			if (_lastObj) 
			{
				var k:int = (_effect == 0) ? Math.ceil(Math.random() * 16 + 1) : _effect;
				var _mask:Sprite;

				if (k == 1)
				{
					_nowObj.y = -this.stage.stageHeight;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,y:0,transition:"linear",onComplete:removeOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 2)
				{
					_nowObj.y = this.stage.stageHeight;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,y:0,transition:"linear",onComplete:removeOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 3)
				{
					_nowObj.x = -this.stage.stageWidth
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,x:0,transition:"linear",onComplete:removeOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 4)
				{
					_nowObj.x = this.stage.stageWidth;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,x:0,transition:"linear",onComplete:removeOldElement, onCompleteParams:[_lastObj] });
				}
				else
				if (k == 5)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 6)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 7)
				{
					_mask = new Sprite();
					_mask.x = this.stage.stageWidth / 2;
					_mask.y = this.stage.stageHeight / 2;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(-this.stage.stageWidth / 2, -this.stage.stageHeight / 2, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 8)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 9)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 10)
				{
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					_mask.graphics.beginFill(0xff0000, 1);
					_mask.graphics.drawRect(0, 0, this.stage.stageWidth, this.stage.stageHeight);
					_mask.graphics.endFill();
					_mask.scaleX = 0;
					_mask.scaleY = 0;
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_mask,{time:_delay,delay:_switchDelay,scaleX:1,scaleY:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 11)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect11(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 12)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect12(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				if (k == 13)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect13(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else 
				if (k == 14)
				{
					_nowObj.alpha = 0.1;
					_mask = new Sprite();
					_mask.x = 0;
					_mask.y = 0;
					
					addEffect14(_mask);
					
					_nowObj.addChild(_mask);
					_nowObj.mask = _mask;
					Tweener.addTween(_nowObj,{time:_delay,delay:_switchDelay,alpha:1,transition:"linear",onComplete:removeMaskOldElement, onCompleteParams:[_lastObj,_mask,_nowObj] });
				}
				else
				{

					_nowObj.alpha = 0.1;
					Tweener.addTween(_nowObj, { time:_delay, delay:_switchDelay, alpha:1,transition:"linear",onComplete:removeOldElement, onCompleteParams:[_lastObj]  } );
				}
			}
			else
			{
				_nowObj.alpha = 0.1;
				Tweener.addTween(_nowObj,{time:_delay,alpha:1});
			}
			_lastObj = _nowObj;
			_nowObj = null;
			
			if (_params && _params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete']();
			
		}
		
		private function addEffect11(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(i*j+j)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		/**
		 *  add effect 12
		 */
		private function addEffect12(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			var k3:int = 0;
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(k3++)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		private function addEffect13(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 100);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			var k3:int = 0;
			for (var j:int = 0; j < k2;j++ )
			{
				for (var i:int = 0; i < k1;i++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawRect(0, 0, 100, 50);
					sp.graphics.endFill();
					
					sp.x = i * 100;
					sp.y = j * 50;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay/(k1*k2), delay:(k3++)* _delay/(k1*k2),transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		private function addEffect14(mc:Sprite):void
		{
			var k1:int = Math.ceil(this.stage.stageWidth / 50);
			var k2:int = Math.ceil(this.stage.stageHeight / 50);
			for (var i:int = 0; i < k1;i++ )
			{
				for (var j:int = 0; j < k2;j++ )
				{
					var sp:Sprite = new Sprite();
					sp.graphics.beginFill(0xff0000, 1);
					sp.graphics.drawCircle(0,0,60);
					sp.graphics.endFill();
					
					sp.x = i * 50 + 50;
					sp.y = j * 50 + 25;
					
					sp.scaleX = 0;
					sp.scaleY = 0;
					Tweener.addTween(sp, { time:_delay, delay:0,transition:"linear", scaleX:1, scaleY:1 } );
					mc.addChild(sp);
				}
			}
		}
		
		/**
		 * onResize
		 */
		private function onResizer(evt:Event):void
		{
			
		}
		
		/**
		 *  onProgressEvent
		 */
		private function onProgressEvent(params:Object = null):void
		{
			if (_params && _params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
	}
}