﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BgImageSwf
 *
 * @version 1.0
 * @since  2010-06-24
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
package com.activetofocus.utils
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import com.activetofocus.utils.LoaderData;
	import com.activetofocus.events.LoadDataEvent;
	
	public class BgImageSwf extends Sprite
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * style
		 */
		private var _align:String;
		
		/**
		 * data
		 */
		private var _stage:Stage;
		
		private var _params:Object;
		
		private var _qloader:Qloader;
		
		/**
		 * show sprite
		 */
		private var _sp:Sprite;
		
		private var _mask:Sprite;
		
		
		/**
    	 *  constructor
     	 */
		public function BgImageSwf(stage:Stage,params:Object= null) 
		{	
			_mask = new Sprite();
			addChild(_mask);
			this.mask = _mask;
			_stage = stage;
			_params = params;
			this.addEventListener(Event.REMOVED_FROM_STAGE, onRemove);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load 
		 */
		public function load(url:String,style:Object):void 
		{
			_align = style.stagealign;
			_stage.addEventListener(Event.RESIZE, onResize);
			
			_qloader = new Qloader({itemIOErrorFun:onLoaderImageErrorEvent,itemCompleteFun:onLoaderImageCompleteEvent,itemProgressFun:onProgressEvent});
			_qloader.load((url));
			_qloader.execute();
			
		}
		
		public function close():void
		{
			if (_qloader) _qloader.removeAll();
			Clear.removeEvent(this,Event.REMOVED_FROM_STAGE, onRemove);
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader image error
		 */
		private function onLoaderImageErrorEvent(params:Object):void
		{
			trace("onLoaderImageErrorEvent");
		}
		
		/**
		 * load progress event
		 */
		private function onProgressEvent(params:Object):void
		{
			if (_params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * loader complete
		 */
		private function onLoaderImageCompleteEvent(params:Object):void 
		{
		
			_sp = new Sprite();
			_sp.addChild(params.data);
			addChild(_sp);
			
			onResize(null);
			
			if (_params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete'](params);
		}
		
		
		/**
		 * on resize
		 */
		private function onResize(evt:*):void
		{
			var sw:Number = _stage.stageWidth;
			var sh:Number = _stage.stageHeight;
			
			_mask.graphics.clear();
			_mask.graphics.beginFill(0xff0000, 1);
			_mask.graphics.drawRect(0, 0, sw, sh);
			_mask.graphics.endFill();
			
			if (_sp)
			{
				_sp.scaleX = 1;
				_sp.scaleY = 1;
				
				var k1:Number = Number(sw/_sp.width);
				var k2:Number = Number(sh/_sp.height);
				
				var sc:Number = k1 < k2 ? k2 : k1;
				
				_sp.scaleX = sc;
				_sp.scaleY = sc;
				
				switch(_align)
				{
					case "left_top":
							_sp.x = _sp.y = 0;
							
							break;
					case "right_top":
							_sp.x = sw - _sp.width;
							_sp.y = 0;
							break;
					case "center":
							_sp.x = (sw - _sp.width)/2;
							_sp.y = (sh - _sp.height)/2;
							break;
					case "left_bottom":
							_sp.x = 0;
							_sp.y = sh - _sp.height;
							break;
					case "right_bottom":
							_sp.x = sw - _sp.width;
							_sp.y = sh - _sp.height;
							break;
				}
			}
		}
		
		/**
		 * remove from stage
		 */
		public function onRemove(evt:Event):void 
		{
			this.removeEventListener(Event.REMOVED_FROM_STAGE, onRemove);
			_stage.removeEventListener(Event.RESIZE, onResize);
			if (_sp) removeChild(_sp);
		}

	}	
}