﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * BgVideo
 *
 * @version 1.0
 * @since  2010-06-24
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
package com.activetofocus.utils
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.AsyncErrorEvent;
	import flash.events.Event;
    import flash.events.NetStatusEvent;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.URLRequest;
	import flash.system.LoaderContext;
	import flash.media.SoundTransform;
	import flash.media.SoundMixer;
	import flash.display.Stage;
	import com.activetofocus.utils.LoaderData;
	import com.activetofocus.events.LoadDataEvent;
	
	public class BgVideo extends Sprite
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * style
		 */
		private var _align:String;
		private var _buffertime:Number;
		private var _timeplay:Number;
		private var _volume:Number;
		
		private var _clientObject:Object
		private var _netConnection:NetConnection;
		private var _netStream:NetStream;
		private var _soundTransform:SoundTransform;
		private var _video:Video;
		
		private var _count:int;
		private var _isStart:Boolean;
       
		/**
		 * data
		 */
		private var _stage:Stage;
		
		private var _params:Object;
		
		/**
		 * show sprite
		 */
		private var _sp:Sprite;
		private var _mask:Sprite;
		/**
    	 *  constructor
     	 */
		public function BgVideo(stage:Stage,params:Object= null) 
		{	
			_mask = new Sprite();
			addChild(_mask);
			this.mask = _mask;
			_stage = stage;
			_params = params;
			this.addEventListener(Event.REMOVED_FROM_STAGE, onRemove);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load 
		 */
		public function load(url:String,style:Object):void 
		{
			_stage.addEventListener(Event.RESIZE, onResize);
			
			_align 			= style.stagealign;
			_buffertime		= style.videobuffertime;
			_timeplay		= style.videotimeplay;
			_volume			= style.videovolume;
			
			_clientObject = new Object();
			_netConnection = new NetConnection();
			_netConnection.connect(null);

			_netStream                  = new NetStream(_netConnection);
			_netStream.bufferTime       = _buffertime;
			_netStream.client           = _clientObject;
			_netStream.checkPolicyFile  = true;
			_netStream.addEventListener(NetStatusEvent.NET_STATUS, onNetStatus);

			_video                  = new Video();						
			_video.smoothing        = true;			
			_video.attachNetStream(_netStream);
			_soundTransform		   = new SoundTransform(_volume);
			_netStream.soundTransform   = _soundTransform;	
			_netStream.play(url);
			
			_sp = new Sprite();
			_sp.addChild(_video);
			addChild(_sp);
		}
		
		public function close():void
		{
			_netStream = null;
			_video.attachNetStream(null);
			Clear.removeEvent(_stage, Event.RESIZE, onResize);
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		/**
		 * net status
		 */
		private function onNetStatus(evt:NetStatusEvent):void 
		{
			switch(evt.info.code) {
				case "NetStream.Play.Start":
					if (!_isStart)
					{
						_isStart = true;
						onResize(null);
						if (_params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete'](null);
					}
					break;
				case "NetStream.Play.StreamNotFound":
					onRemove(null);
					break;
				case "NetStream.Play.Stop":
					if (_timeplay  == 0) 
					{
						_netStream.seek(0);
						return
					} 
					else if(_count == (_timeplay - 1))
					{
						return;
					}
					else 
					{					
						_netStream.seek(0);
						_count++;
						return
					}
			}
		}
		
		/**
		 * on resize
		 */
		private function onResize(evt:*):void
		{
			var sw:Number = _stage.stageWidth;
			var sh:Number = _stage.stageHeight;
			
			_mask.graphics.clear();
			_mask.graphics.beginFill(0xff0000, 1);
			_mask.graphics.drawRect(0, 0, sw, sh);
			_mask.graphics.endFill();
			
			if (_sp)
			{
				_sp.scaleX = 1;
				_sp.scaleY = 1;
				
				var k1:Number = Number(sw/_sp.width);
				var k2:Number = Number(sh/_sp.height);
				
				var sc:Number = k1 < k2 ? k2 : k1;
				
				_sp.scaleX = sc;
				_sp.scaleY = sc;
				
				switch(_align)
				{
					case "left_top":
							_sp.x = _sp.y = 0;
							break;
					case "right_top":
							_sp.x = sw - _sp.width;
							_sp.y = 0;
							break;
					case "center":
							_sp.x = (sw - _sp.width)/2;
							_sp.y = (sh - _sp.height)/2;
							break;
					case "left_bottom":
							_sp.x = 0;
							_sp.y = sh - _sp.height;
							break;
					case "right_bottom":
							_sp.x = sw - _sp.width;
							_sp.y = sh - _sp.height;
							break;
				}
			}
		}
		
		/**
		 * remove from stage
		 */
		private function onRemove(evt:*):void
		{
			_stage.removeEventListener(Event.RESIZE, onResize);
			this.removeEventListener(Event.REMOVED_FROM_STAGE, onRemove);
			if (_netStream) 
			{
				_netStream.pause();
				_netStream.removeEventListener(NetStatusEvent.NET_STATUS, onNetStatus);
			}
            if(_sp) removeChild(_sp);
			if(_video) _video.smoothing = false;		
			
			_netStream = null;
			_netConnection= null;
			onResize(null);
		}
	}	
}