﻿////////////////////////////////////////////////////////
//
//  Copyright 2010 www.activetofocus.com  All Rights Reserved.
//
////////////////////////////////////////////////////////

/**
 * FluTextArea achieve fluorescent effect of making 
 * textArea becomes more brilliant. This class can not
 *  only directly in the FLASH as3.0 program to use and
 *  can be used in the FLEX as3.0 program. In flash cs3
 *  is not TextArea, this class implements the basic 
 * functions of textArea, also showed the scroll bar, 
 * very use. If you do not need to use the fluorescent 
 * effect, direct access to TextArea, you can directly 
 * on the class fluorescenceEffect function can be 
 * disabled, and at the same time you can enhance the 
 * function of the class to better use.
 */

package com.activetofocus.utils
{

	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.text.*;

	public class FluTextArea extends Sprite
	{
		/**
		 *  textField Property
		 */
		private var _textField : TextField;// textField object
		private var _text : String = "";//textField text
		private var _htmlText : String = "";//textField htmltext
		private var _useHtmlText : Boolean;//Whether to use htmltext
		private var _fontSize : int = 12;//textField font size
		private var _color : uint = 0x1b1b1b;//textField font color
		private var _bold : Boolean;//Whether to use bold text
		private var _italic : Boolean //Whether to use italic text
		private var _fontFamily : String = "Arial";//textField font family
		private var _align : String = "left";// textField font align
		private var _editable : Boolean;//Whether to edit text
		private var _selectable : Boolean = true;////Whether to select text area
		
		/**
		 *  Fluorescence results Property
		 */
		private var _useFluor : Boolean = true;//Whether to use Fluorescence effect
		private var _fcolor : uint = 0x45e200;//the color value of fluorescence effects
		private var _falpha : Number = 0.7;//the alpha value of fluorescence effects
		private var _xBlur : Number = 7;//the xBlur value of fluorescence effects
		private var _yBlur : Number = 7;//the yBlur value of fluorescence effects
		private var _strength : Number = 2;//the strength value of fluorescence effects
		private var _knockout : Boolean = false;//the knockout value of fluorescence effects
		
		/**
		 *  Scroll bar properties
		 */
		private var _scroolPanel : Sprite;//scrollbar sprite
		private var _scroolbgPanel : Sprite;//scrollbar background sprite
		private var _mouseMoveY : Number;//To save the current value of the mouse Y
		private var _scroolNum : Number;//The proportion of the value of scroll bar
		private var _scroolWidth : Number = 12;//Scrollbar width
		
		/**
		 *  Background Properties
		 */
		private var _useBackground : Boolean = true;//the background state of use textField
		private var _backgroundBorderPanel : Sprite;//the textField Border
		private var _backgroundPanel : Sprite;//the background sprite of textField
		private var _backgroundColor : uint = 0x4b4b4b;//the background color of textField
		private var _backgroundAlpha : Number = 0.35;//textField background alpha
		
		/**
		 * FluTextArea Initialization
		 */
		public function FluTextArea()
		{	
			_backgroundPanel = new Sprite();
			addChild(_backgroundPanel);
			
			_textField = new TextField();
			_textField.wordWrap = true;
			_textField.multiline = true;
			//_textField.autoSize = TextFieldAutoSize.CENTER;
			_textField.addEventListener(MouseEvent.MOUSE_WHEEL,scroolTextEvent);
			_textField.addEventListener(Event.SCROLL,scroolTextEvent);
			_textField.addEventListener(Event.CHANGE,changeTextContent);
			//_textField.addEventListener(MouseEvent.CLICK,showBorder);
			addChild(_textField);
			
			this.addEventListener(Event.REMOVED_FROM_STAGE,removeAll);
		}
		
		/**
		 * FluTextArea change the implementation of relevant attributes
		 */
		public function changeText():void
		{
			if(_useHtmlText)
			{
				_textField.htmlText = _htmlText;
			}
			else
			{
				_textField.text = _text;
				_textField.setTextFormat(returnTextFormat());
			}
			
			if(_textField.maxScrollV > 1)
			{
				_textField.width = this.width - _scroolWidth;
				addScroolBGPanel(true);
				addScroolPanel(true);
			}
			else
			{
				_textField.width = this.width;
				addScroolBGPanel(false);
				addScroolPanel(false);
			}
			setBackgroundColor();
			if(_useFluor) fluorescenceEffect();
		}
		
		/**
		* show textField board color
		*/
		private function showBorder($e :MouseEvent):void
		{
			if(_backgroundBorderPanel) this.removeChild(_backgroundBorderPanel);
			_backgroundBorderPanel = new Sprite();
			_backgroundBorderPanel.graphics.lineStyle(1,0x00cc00,0.7);
			_backgroundBorderPanel.graphics.moveTo(0,0);
			_backgroundBorderPanel.graphics.lineTo(_textField.width,0);
			_backgroundBorderPanel.graphics.lineTo(_textField.width,_textField.height);
			_backgroundBorderPanel.graphics.lineTo(0,_textField.height);
			_backgroundBorderPanel.graphics.lineTo(0,0);
			_backgroundBorderPanel.filters = null;
	        var arr : Array = [];
	        arr.push(new GlowFilter(_fcolor,.9,4,4,1,1,false,false));
	        _backgroundBorderPanel.filters = arr;
			addChild(_backgroundBorderPanel);
		}
		
		/**
		 * Editable text in the implementation of change
		 */
		private function changeTextContent($e : Event):void
		{
			if(!_editable) return;
			if(_useHtmlText)
			{
				_htmlText = _textField.htmlText;
			}
			else
			{
				_text = _textField.text;
			}
			
			changeText();
		}
		
		/**
		 * Set FluTextArea Background
		 */
		private function setBackgroundColor():void
		{
			_backgroundPanel.graphics.clear();
			_backgroundPanel.graphics.beginFill(_backgroundColor,_backgroundAlpha);
			_backgroundPanel.graphics.drawRect(0,0,_textField.width,_textField.height);
			_backgroundPanel.graphics.endFill();
			if(_useBackground)
			{
				_backgroundPanel.visible = true;
			}
			else
			{
				_backgroundPanel.visible = false;
			}
		}
		
		/**
		 * Add a scroll bar background to
		 */
		private function addScroolBGPanel($bool : Boolean):void
		{
			if(!$bool)
			{
				if(_scroolbgPanel)
				{
					_scroolbgPanel.visible = false;
				}
				return;
			}
			if(!_scroolbgPanel)
			{
				_scroolbgPanel = new Sprite();
				_scroolbgPanel.x = this.width - 6;
				_scroolbgPanel.graphics.beginFill(0xffffff,.4)
				_scroolbgPanel.graphics.drawRect(0,0,2,this.height)
				_scroolbgPanel.graphics.endFill();
				addChild(_scroolbgPanel);
			}
			_scroolbgPanel.visible = true;
		}
		
		/**
		 * Add FluTextArea scroll bar
		 */
		private function addScroolPanel($bool : Boolean):void
		{
			if(!$bool)
			{
				if(_scroolPanel) _scroolPanel.graphics.clear();
				return;
			}
			if(_scroolPanel)
			{
				_scroolPanel.graphics.clear();
				_scroolPanel.y = 0;
			}
			else
			{
				_scroolPanel = new Sprite();
				_scroolPanel.x = this.width - 8;
				_scroolPanel.buttonMode = true;
				_scroolPanel.addEventListener(MouseEvent.MOUSE_DOWN,startDragScrool);
				addChild(_scroolPanel);
			}
			_scroolPanel.graphics.beginFill(_fcolor,1)
			_scroolPanel.graphics.drawRoundRect(0,0,6,_textField.height - (_textField.maxScrollV-1)*getScroolNum(),0,0)
			_scroolPanel.graphics.endFill();
		}
		
		/**
		 * Start dragging the scroll bar
		 */
		private function startDragScrool($e : MouseEvent):void
		{
			setScroolFlu();
			_mouseMoveY = _textField.mouseY;
			this.stage.addEventListener(MouseEvent.MOUSE_MOVE,startDragMove);
			this.stage.addEventListener(MouseEvent.MOUSE_UP,stopDragMove);
		}
		
		/**
		 * Stop dragging the scroll bar
		 */
		private function stopDragMove($e : MouseEvent = null):void
		{
			clearFlu(_scroolPanel);
			this.stage.removeEventListener(MouseEvent.MOUSE_MOVE,startDragMove);
			this.stage.removeEventListener(MouseEvent.MOUSE_UP,stopDragMove);
		}
		
		/**
		 * Drag the scroll bar is being
		 */
		private function startDragMove($e : MouseEvent):void
		{
			if(_scroolPanel.mouseY < 0 || _scroolPanel.mouseY > this.height)
			{
				_mouseMoveY = _textField.mouseY;
				return;
			}
			var moveNum : Number = _textField.mouseY - _mouseMoveY;
			if(moveNum > 0)
			{
				if(_textField.scrollV == _textField.maxScrollV)
				{
					_scroolPanel.y = _textField.height - _scroolPanel.height;
				}
				else
				{
					_textField.scrollV = _textField.scrollV + 1;
					_scroolPanel.y += _scroolNum;
				}
			}
			else
			{
				if(_textField.scrollV == 1)
				{
					_scroolPanel.y = 0;
				}
				else
				{
					_textField.scrollV = _textField.scrollV - 1;
					_scroolPanel.y -= _scroolNum;
				}
			}
			_mouseMoveY = _textField.mouseY;
		}
		
		/**
		 * textField Scroll event is triggered
		 */
		private function scroolTextEvent($e : * ):void
		{
			if(_textField.maxScrollV == 1 || !_scroolPanel) return;
			if(_textField.scrollV == _textField.maxScrollV )
			{
				_scroolPanel.y = _textField.height - _scroolPanel.height;
			}
			else
			if(_textField.scrollV == 1)
			{
				_scroolPanel.y = 0;
			}
			else
			{
				if($e is MouseEvent)
				{
					_scroolPanel.y -= _scroolNum * $e.delta;
				}
				else
				{
					_scroolPanel.y =(_textField.scrollV -1)*_scroolNum;
				}
			}
		}
		
		/**
		 * Dealing with fluorescent effect
		 */
		public function fluorescenceEffect():void
		{
			_textField.filters = null;
	        var arr : Array = [];
	        arr.push(new GlowFilter(_fcolor,_falpha,_xBlur,_yBlur,_strength,1,false,_knockout));
	        _textField.filters = arr;
		}
		
		/**
		 * Set textField Format
		 */
		private function returnTextFormat():TextFormat
		{
			var font : TextFormat = new TextFormat();
			font.font = _fontFamily;
			font.size = _fontSize;
			font.align = _align;
			font.color = _color;
			return font;
		}
		
		/**
		* Set the scroll bar effect
		*/
		private function setScroolFlu():void
		{
			_scroolPanel.filters = null;
	        var arr : Array = [];
	      //  arr.push(new GlowFilter(_fcolor,.6,3,3,2,1,false,false));
	        _scroolPanel.filters = arr;
		}
		
		/**
		* To specify clearly the effect of the object
		*/
		private function clearFlu($obj : Object):void
		{
			$obj.filters = null;
	        var arr : Array = [];
	        arr.push(new GlowFilter(_fcolor,0,0,0,1,1,false,false));
	       	$obj.filters = arr;
		}
		
		/**
		 * To obtain the proportion of the value of scroll bar
		 */
		private function getScroolNum(): Number
		{
			for(var i : Number = 1; ;)
			{
				if((i * (_textField.maxScrollV - 1) + 2*_textField.height/15)  >= _textField.height)
				{
					i = i -0.01;
				}
				else
				{
					break;
				}
			}
			_scroolNum = i;
			return _scroolNum;
		}
	
	///////////////// get set values
		public function get text(): String
		{
			return _text;
		}
		
		public function set text($text : String):void
		{
			_text = $text;
			_useHtmlText = false;
			changeText();
		}
		
		public function get htmlText(): String
		{
			return _htmlText;
		}
		
		public function set htmlText($htmlText : String):void
		{
			_htmlText = $htmlText;
			_useHtmlText = true;
			changeText();
		}
		
		public function get fontSize():Number
		{
			return _fontSize;
		}
		
		public function set fontSize($fontSize : Number):void
		{
			_fontSize = $fontSize;
			changeText();
		}
		
		public function get bold():Boolean
		{
			return _bold;
		}
		
		public function set bold($bold : Boolean):void
		{
			_bold = $bold;
			changeText();
		}
		
		public function get italic():Boolean
		{
			return _italic;
		}
		
		public function set italic($italic : Boolean):void
		{
			_italic = $italic;
			changeText();
		}
		
		public function get fontFamily():String
		{
			return _fontFamily;
		}
		
		public function set fontFamily($fontFamily : String):void
		{
			_fontFamily = $fontFamily;
			changeText();
		}
		
		public function get align():String
		{
			return _align;
		}
		
		public function set align($align : String):void
		{
			_align = $align;
			changeText();
		}
		
		public function get color():uint
		{
			return _color;
		}
		
		public function set color($color : uint):void
		{
			_color = $color;
			changeText();
		}
		
		public function get editable():Boolean
		{
			return _editable;
		}
		
		public function set editable($editable : Boolean):void
		{
			if($editable)
			{
				_textField.type = TextFieldType.INPUT;
			}
			else
			{
				_textField.type = TextFieldType.DYNAMIC;
			}
			_editable = $editable;
		}
		
		public function get selectable():Boolean
		{
			return _selectable;
		}
		
		public function set selectable($selectable : Boolean):void
		{
			_textField.selectable = _selectable = $selectable;
		}
		
		public function get useFluor():Boolean
		{
			return _useFluor;
		}
		
		public function set useFluor($useFluor : Boolean):void
		{
			_useFluor = $useFluor;
			if(!_useFluor)
			{
				clearFlu(_textField);
			}
		}
		
		public function get fluColor():uint
		{
			return _fcolor;
		}
		
		public function set fluColor($fluColor : uint):void
		{
			_fcolor = $fluColor;
			changeText();
		}
		
		public function get fluAlpha():Number
		{
			return _falpha;
		}
		
		public function set fluAlpha($fluAlpha : Number):void
		{
			_falpha = $fluAlpha;
			changeText();
		}
		
		public function get xBlur():Number
		{
			return _xBlur;
		}
		
		public function set xBlur($xBlur : Number):void
		{
			_xBlur = $xBlur;
			changeText();
		}
		
		public function get yBlur():Number
		{
			return _yBlur;
		}
		
		public function set yBlur($yBlur : Number):void
		{
			_yBlur = $yBlur;
			changeText();
		}
		
		public function get strength():Number
		{
			return _strength;
		}
		
		public function set strength($strength : Number):void
		{
			_strength = $strength;
			changeText();
		}
		
		public function get knockout():Boolean
		{
			return _knockout;
		}
		
		public function set knockout($knockout : Boolean):void
		{
			_knockout = $knockout;
			changeText();
		}
		
		public function get useBackground():Boolean
		{
			return _useBackground;
		}
		
		public function set useBackground($useBackground : Boolean):void
		{
			_useBackground = $useBackground;
			changeText();
		}
		
		public function get backgroundColor():uint
		{
			return _backgroundColor;
		}
		
		public function set backgroundColor($backgroundColor : uint):void
		{
			_backgroundColor = $backgroundColor;
			changeText();
		}
		
		public function get backgroundAlpha():Number
		{
			return _backgroundAlpha;
		}
		
		public function set backgroundAlpha($backgroundAlpha : Number):void
		{
			_backgroundAlpha = $backgroundAlpha;
			changeText();
		}
		
		override public function set width($width : Number):void
		{
			_textField.width = $width;
			changeText();
		}
		
		override public function set height($height : Number):void
		{
			_textField.height = $height;
			changeText();
		}
		///////////////////////////// removeEventListener
		private function removeAll(evt:Event):void
		{
			this.removeEventListener(Event.REMOVED_FROM_STAGE,removeAll);
			_textField.removeEventListener(MouseEvent.MOUSE_WHEEL,scroolTextEvent);
			_textField.removeEventListener(Event.SCROLL,scroolTextEvent);
			_textField.removeEventListener(Event.CHANGE,changeTextContent);
		}
	}
}