﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * LoadXmlData 
 *
 * @version 1.0
 * @since  2010-04-03
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
	
package com.activetofocus.utils
{
	import com.activetofocus.events.LoadDataEvent;
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.display.Loader;
	
	public class LoadXmlData extends EventDispatcher
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------

		/**
    	 *  constructor
     	 */
		public function LoadXmlData()
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *  start loader xml file
		 */
		public function load(path:String):void
		{
			var loader : URLLoader   = new URLLoader();
			loader.addEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			loader.addEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			loader.addEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			loader.load(new URLRequest(path));
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader xml file error
		 */
		private function onLoaderErrorEvent(evt:IOErrorEvent):void
		{
			trace("xml files load path error");
			evt.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR,onLoaderErrorEvent);
			evt.currentTarget.removeEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_ERROR));
		}
		
		/**
		 *  loader progress
		 */
		private function onLoaderProgressEvent(evt:ProgressEvent):void
		{
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_PROGRESS, {percent:(evt.bytesTotal == 0 ? 0 : Math.ceil(evt.bytesLoaded*100/evt.bytesTotal))}));
		}
		
		/**
		 *  loader xml file complete
		 */
		private function onLoaderCompleteEvent(evt:Event):void
		{
			evt.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR,onLoaderErrorEvent);
			evt.currentTarget.removeEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_COMPLETE,new XML(evt.currentTarget.data)));
		}
	}
}