﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * LoaderData 
 *
 * @version 1.0
 * @since  2010-04-03
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
	
package com.activetofocus.utils
{
	import com.activetofocus.events.LoadDataEvent;
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.display.Loader;
	import flash.events.ProgressEvent;
	
	public class LoaderData extends EventDispatcher
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * loader
		 */
		private var _loader:Loader;
		
		/**
		 * params
		 */
		private var _params:*;
		
		/**
    	 *  constructor
     	 */
		public function LoaderData()
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *  start loader file
		 */
		public function load(path:String,params:* = null):void
		{
			_params = params;
			_loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			_loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			_loader.load(new URLRequest(path));
		}
		
		/**
		 * unload 
		 */
		public function unload():void
		{
			if (!_loader) return;
			try
			{
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			}catch (e:Error) { };
			try
			{
			_loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			}catch (e:Error) { };
			try
			{
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoaderCompleteEvent);
			}catch (e:Error) { };
			try
			{
			_loader.unload();
			}catch (e:Error) { };
		}
		
		/**
		 * get loader
		 */
		public function get loader():Loader
		{
			return _loader;
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader xml file error
		 */
		private function onLoaderErrorEvent(evt:IOErrorEvent):void
		{
			evt.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			evt.currentTarget.removeEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			evt.currentTarget.removeEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_ERROR));
			trace("files load path error");
		}
		
		/**
		 *  loader progress
		 */
		private function onLoaderProgressEvent(evt:ProgressEvent):void
		{
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_PROGRESS, {percent:(evt.bytesTotal == 0 ? 0 : Math.ceil(evt.bytesLoaded*100/evt.bytesTotal))}));
		}
		
		/**
		 *  loader xml file complete
		 */
		private function onLoaderCompleteEvent(evt:Event):void
		{
			evt.currentTarget.removeEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			evt.currentTarget.removeEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			evt.currentTarget.removeEventListener(Event.COMPLETE,onLoaderCompleteEvent);
			dispatchEvent(new LoadDataEvent(LoadDataEvent.LOAD_COMPLETE,(_params != null ? {loader:evt.currentTarget.loader,params:_params} : evt.currentTarget.loader)));
		}
	}
}