﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * Facebook Fan Template V1
 *
 * @version 1.0
 * @since  2011-04-26
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	import caurina.transitions.Tweener;
	import com.activetofocus.utils.SuperMovieClip;
	import com.activetofocus.utils.ObjectUtils;
	import com.activetofocus.utils.Qloader;
	import com.activetofocus.utils.DisplayLine;
	import flash.display.Loader;
	import flash.display.Sprite;
	
	public class LogoUtils extends SuperMovieClip
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _params:Object =
				{
					src:"",
					time:0.6,
					onStart:null,
					onComplete:null,
					onIOError:null,
					onProgress:null
				};
		
		/**
		 * loader
		 */
		private var _qloader:Qloader;
		
		/**
    	 *  constructor
     	 */
		public function LogoUtils(params:Object)
		{
			_params = ObjectUtils.updateParams(_params,params);
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			initLogo();
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *  add logo
		 */
		private function initLogo():void
		{
			if (_params['src'].length == 0) return; 
			_qloader = new Qloader({itemIOErrorFun:onLoaderImageErrorEvent,itemCompleteFun:onLoaderImageCompleteEvent,itemProgressFun:onProgressEvent});
			_qloader.load(_params['src']);
			_qloader.execute();
			if (_params && _params['onStart'] != null && _params['onStart'] is Function) _params['onStart'](null);
		}
		
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  loader image error
		 */
		private function onLoaderImageErrorEvent(params:Object):void
		{
			trace("onLoaderImageErrorEvent");
		}
		
		/**
		 * load progress event
		 */
		private function onProgressEvent(params:Object):void
		{
			if (_params['onProgress'] != null && _params['onProgress'] is Function) _params['onProgress'](params);
		}
		
		/**
		 * loader complete
		 */
		private function onLoaderImageCompleteEvent(params:Object):void 
		{
			var lo:Loader = params.data as Loader;
			lo.alpha = 0;
			addChild(lo);
			Tweener.addTween(lo, { time:_params['time'], transition:"linear",alpha:1} );
			if (_params['onComplete'] != null && _params['onComplete'] is Function) _params['onComplete'](params);
		}
		
	}
}