﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * PageItemsUtils
 *
 * @version 1.0
 * @since  2011-04-10
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	
	public class PageItemsUtils
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		
		private var _hLen:int;
		private var _vLen:int;
		private var _cLen:int;
		
		private var _itemId:int = 0;
		
		private var _list:Array;
		private var _changeFun:Function;
		
		private var _prevcan:Boolean;
		private var _nextcan:Boolean;
		
		private var _currList:Array;
		private var _delList:Array;
		private var _moveList:Array;
		private var _addList:Array;
		
		private var _preClick:Boolean;
		
		/**
    	 *  constructor
     	 */
		public function PageItemsUtils(hLen:int,vLen:int,cLen:int,changeFun:Function)
		{
			_hLen		= hLen;
			_vLen		= vLen;
			_cLen		= cLen;
			_changeFun 	= changeFun;
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * prev list
		 */
		public function prev():void
		{
			if (_itemId < 0) return;
			_preClick = true;
			changeList();
		}
		
		/**
		 * next list
		 */
		public function next():void
		{
			if (_itemId + _vLen * _hLen >= _list.length) return;
			_preClick = false;
			changeList();
		}
		
		/**
		 * init
		 */
		private function init():void
		{
			if (!_list || _list.length == 0) _list = [];
			changeList(true);
		}
		
		/**
		 *  change list
		 */
		private function changeList(isFirst:Boolean = false):void
		{
			_prevcan = false;
			_nextcan = false;
			
			//trace(_itemId , _itemId + _vLen*_hLen , _list.length);
			
			if (isFirst)
			{
				_currList = [];
				_delList = [];
				_addList = [];
				_moveList = [];
				for (var i:int = _itemId; i < _vLen * _hLen && i < _list.length; i++ )
				{
					_moveList.push(_list[i]);
					_currList.push(_list[i]);
				}
				
				if (_itemId > 0) _prevcan = true;
				if ((_itemId + _vLen*_hLen) < _list.length) _nextcan = true;
				
				if (_changeFun != null) _changeFun(true);
			}
			else
			{
				getPageList();
			}
		}
		
		/**
		 *  get new list
		 */
		private function getPageList():void
		{
			if (!_list || _list.length == 0) return;
			
			_delList = [];
			_addList = [];
			_moveList = [];
			if (_currList && _currList.length != 0)
			{
				for (var i:int = 0; i < _currList.length;i++ )
				{
					if (_preClick)
					{
						if (i >= _currList.length - _cLen && i > (_vLen * _hLen - _cLen - 1))
						{
							_delList.push(_currList[i]);
						}
						else
						{
							_moveList.push(_currList[i]);
						}
					}
					else
					{
						if (i < _cLen)
						{
							_delList.push(_currList[i]);
						}
						else
						{
							_moveList.push(_currList[i]);
						}
					}
				}
			}
			
			_currList = [];
			
			if (_preClick)
			{
				var n:int= _itemId - 1;
				for (var j:int = n; j >= 0 && j > (n-_cLen);j-- )
				{
					_itemId--;
					_addList.unshift(_list[j]);
				}
				
				for each(var obj1:* in _addList)
				{
					_currList.push(obj1);
				}
				
				for each(var obj2:* in _moveList)
				{
					_currList.push(obj2);
				}
			}
			else
			{
			//	trace("_itemId1 ",_itemId);
				var m:int = (_itemId + _vLen * _hLen);
				for (var k:int =  m; k <  ( m + _cLen) && k < _list.length;k++ )
				{
					_itemId++;
					_addList.push(_list[k]);
				}
				
				_itemId += (_cLen - _addList.length)
			//	trace("_itemId2 ",_itemId);
				for each(var obj3:* in _moveList)
				{
					_currList.push(obj3);
				}
				
				for each(var obj4:* in _addList)
				{
					_currList.push(obj4);
				}
			}
			
			if (_itemId > 0) _prevcan = true;
			if ((_itemId + _vLen*_hLen) < _list.length) _nextcan = true;
			
			if (_changeFun != null) _changeFun(false);
		}
		
		//--------------------------------------
		//  GET/SET
		//--------------------------------------
		
		public function set list(value:Array):void
		{
			_list = value;
			init();
		}
		
		public function get prevcan():Boolean
		{
			return _prevcan;
		}
		
		public function get nextcan():Boolean
		{
			return _nextcan;
		}
		
		public function get moveList():Array
		{
			return _moveList;
		}
		
		public function get delList():Array
		{
			return _delList;
		}
		
		public function get addList():Array
		{
			return _addList;
		}
		
	}
}