﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * PageUtils
 *
 * @version 1.0
 * @since  2011-03-20
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	
	public class PageUtils
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _list:Array;
		private var _len:int;
		private var _page:int;
		private var _changeFun:Function;
		
		private var _prevcan:Boolean;
		private var _nextcan:Boolean;
		private var _max:int;
		
		/**
    	 *  constructor
     	 */
		public function PageUtils(len:int,changeFun:Function)
		{
			_len 		= len;
			_changeFun 	= changeFun;
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * prev list
		 */
		public function prev():void
		{
			if (_page < 0) return;
			_page--;
			changeList();
		}
		
		/**
		 * next list
		 */
		public function next():void
		{
			if (_page >= _max) return;
			_page++;
			changeList();
		}
		
		/**
		 * init
		 */
		private function init():void
		{
			if (!_list || _list.length == 0) _list = [];
			_max = Math.ceil(_list.length / _len);
			changeList();
		}
		
		/**
		 *  change list
		 */
		private function changeList():void
		{
			_prevcan = false;
			_nextcan = false;	
			if (!_max == 0)
			{
				if (_page > 0) _prevcan = true;
				if (_page < _max - 1) _nextcan = true;
			}
			//trace(_changeFun);
			if (_changeFun != null)
			{
				_changeFun();
			}
		}
		
		/**
		 *  get new list
		 */
		private function getPageList():Array
		{
			if (!_list || _list.length == 0) return [];
			
			var arr:Array = [];
			for (var i:int = _page * _len; i < (_page + 1) * _len && i < _list.length; i++)
			{
				arr.push(_list[i]);
			}
			
			return arr;
		}
		
		//--------------------------------------
		//  GET/SET
		//--------------------------------------
		
		public function set list(value:Array):void
		{
			_list = value;
			init();
		}
		
		public function set page(value:int):void
		{
			_page = value;
		}
		
		public function set len(value:int):void
		{
			_len = value;
		}
		
		public function get max():int
		{
			return _max;
		}
		
		public function get page():int
		{
			return _page;
		}
		
		public function get prevcan():Boolean
		{
			return _prevcan;
		}
		
		public function get nextcan():Boolean
		{
			return _nextcan;
		}
		
		public function get currectlist():Array
		{
			return getPageList();
		}
		
	}
}