﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * PayPalUtils 
 *
 * @version 1.0
 * @since  2010-04-03
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	public class PayPalUtils
	{
		
		import flash.net.URLRequest;
		import flash.net.URLVariables;
		import flash.net.navigateToURL;
		
		/**
		 *  buy now
		 */
		public static function buyNow(item:Object,account:String = "team@activetofocus.com",currency:String = "USD"):void
		{
			var pd:URLVariables = new URLVariables();
			// paypal information
			pd.cmd = "_xclick";
			pd.business = account;
			pd.no_shipping = "2";
			pd.no_note = "1";
			pd.currency_code = currency;
			// item information
			pd.item_name = item.name;
			pd.amount = item.amount;
			pd.item_number = item.number;
			pd.quantity = item.quantity;
			// open paypal window
			sendURLRequest(pd);
		}
		
		/**
		 *  add to cart
		 */
		public static function addToCart(item:Object,account:String = "team@activetofocus.com",currency:String = "USD"):void
		{
			var pd:URLVariables = new URLVariables();
			// paypal information
			pd.add = "1";
			pd.cmd = "_cart";
			pd.business = account;
			pd.no_shipping = "2";
			pd.no_note = "1";
			pd.currency_code = currency;
			pd.tax = "0";
			// item information
			pd.item_name = item.name;
			pd.amount = item.amount;
			// open paypal window
			sendURLRequest(pd);
		}
		
		/**
		 *  upload cart
		 */
		public static function uploadCart(items:Array,account:String = "team@activetofocus.com",currency:String = "USD"):void
		{
			var pd:URLVariables = new URLVariables();
			// paypal information
			pd.cmd = "_cart";
			pd.upload = "1";
			pd.business = account;
			pd.currency_code = currency;
			// item information
			for(var i:int=1; i<=items.length; i++)
			{
				pd["item_name_" + i] = items[i-1].name;
				pd["amount_" + i] = items[i-1].amount;
				pd["quantity_" + i] = items[i-1].quantity;
			}
			// open paypal window
			sendURLRequest(pd);
		}
		
		/**
		 *  upload Item
		 */
		public static function uploadItem(item:Object,account:String = "team@activetofocus.com",currency:String = "USD"):void
		{
			var pd:URLVariables = new URLVariables();
			// paypal information
			pd.cmd = "_xclick";
			pd.business = account;
			pd.currency_code = currency;
			// item information
			pd.item_name = item.name;
			pd.amount = item.amount;
			// open paypal window
			sendURLRequest(pd);
		}
		
		/**
		 *  donation
		 */
		public static function donation(item:Object,account:String = "team@activetofocus.com",currency:String = "USD"):void
		{
			var pd:URLVariables = new URLVariables();
			// paypal information
			pd.cmd = "_xclick";
			pd.business = account;
			pd.no_shipping = "2";
			pd.no_note = "1";
			pd.currency_code = currency;
			pd.tax = "0";
			// item information
			pd.item_name = item.name;
			pd.item_number = item.number;
			pd.amount = item.amount;
			// open paypal window
			sendURLRequest(pd);
		}
		
		/**
		 *  send to paypal
		 */
		private static function sendURLRequest(pd:URLVariables,method:String="POST"):void
		{
			var req:URLRequest = new URLRequest("https://www.paypal.com/cgi-bin/webscr");
			req.data = pd;
			req.method = method;
			navigateToURL(req,"_blank");
		}

	}
}