﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * Qloader
 *
 * @version 1.0
 * @since  2011-03-20
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	
	public class Qloader extends EventDispatcher
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * loader Max Number
		 */
		private var QloaderNumber:int = 5;
		private var QloaderLoadTime:int = 2000;
		
		/**
		 *  data
		 */
		private var _loaderlist:Array;
		
		private var _timer:Timer;
		
		private var _qloaderCompleteFun:Function;
		
		private var _itemIOErrorFun:Function;
		private var _itemCompleteFun:Function;
		private var _itemProgressFun:Function;
		/**
    	 *  constructor
     	 */
		public function Qloader(params:Object = null)
		{
			if(params != null)
			{
				if (params['QloaderNumber']) QloaderNumber = params['QloaderNumber'];
				if (params['QloaderLoadTime']) QloaderLoadTime = params['QloaderLoadTime'];
				if(params['qloaderCompleteFun']) _qloaderCompleteFun = params['qloaderCompleteFun'];
				if(params['itemIOErrorFun']) _itemIOErrorFun = params['itemIOErrorFun'];
				if(params['itemCompleteFun']) _itemCompleteFun = params['itemCompleteFun'];
				if(params['itemProgressFun']) _itemProgressFun = params['itemProgressFun'];
			}
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 * load data
		 * @param url
		 * @param params
		 */
		public function load(url:String,params:Object = null):void
		{
			push(new QloaderItem(url,params,this,onItemIOError,onItemComplete,onItemProgress));
		}
		
		/**
		 * start
		 */
		public function execute():void
		{
			loadItems();
		}
		
		/**
		 * remove item from list
		 * @param	item
		 */
		public function removeItem(item:QloaderItem):void
		{
			try
			{
				item.close();
			}catch (e:Error) { };
		}
		
		//--------------------------------------
		//  publish Function
		//--------------------------------------
		
		/**
		 * add item
		 * @param	item
		 */
		private function push(item:QloaderItem):void
		{
			if (!_loaderlist) _loaderlist = [];
			_loaderlist.push({id:_loaderlist.length,item:item});
		}
		
		/**
		 *  remove all item
		 */
		public function removeAll():void
		{
			trace("call removeAll");
			if (!_loaderlist) return;
			for (var i:int = 0; i < _loaderlist.length;i++ )
			{
				try
				{
					trace("removeAll");
					_loaderlist[i]['item'].close();
				}catch (e:Error) { };
			}
		}
		/**
		 * 
		 * @param	item
		 * @param	str
		 */
		public function state(item:QloaderItem,str:String):void
		{
			switch(str) 
			{
				case "stop":
						changeItemArray(item);
						break;
				case "close":
						changeItemArray(item);
						break;
				case "resume":
				
						break;
				case "loadwaitting":
						timerStart();
						break;
				case "loaderror":
						changeItemArray(item);
						break;
				case "loadcomplete":
						changeItemArray(item);
						break;
				case "loading":
				
						break;
			}
			loadItems();
		}
		
		/**
		 * timer start
		 */
		private function timerStart():void
		{
			if (_timer) return;
			//trace("timerStart");
			_timer = new Timer(QloaderLoadTime, 1);
			_timer.addEventListener(TimerEvent.TIMER_COMPLETE, timerComplete);
			_timer.start();
		}
		
		/**
		 * timer close
		 */
		private function timerClose():void
		{
			//trace("timerClose");
			if (_timer)
			{
				_timer.stop();
				Clear.removeEvent(_timer,TimerEvent.TIMER_COMPLETE, timerComplete);
			}
		}
		
		//--------------------------------------
		//  Private Function
		//--------------------------------------
		
		/**
		 * load item
		 */
		private function loadItems():void
		{
			for (var i:int = 0,j:int=0; i < QloaderNumber && j < _loaderlist.length; i++,j++ )
			{
				if (_loaderlist[j]["item"].state == "null")
				{
					_loaderlist[j]["item"].state == "loading";
					_loaderlist[j]["item"].beginload();
				}
				else if (_loaderlist[j]["item"].state == "loading")
				{
					
				}
				else
				{
					i--;
				}
			}
		}
		
		/**
		 * change and delete item
		 * @param	item
		 */
		private function changeItemArray(item:QloaderItem):void
		{
			var arr:Array = [];
			for (var i:int = 0; i < _loaderlist.length;i++ )
			{
				if (_loaderlist[i]["item"] as QloaderItem != item) arr.push( { id:i, item:_loaderlist[i]["item"] } );
			}
			_loaderlist = arr;
			if (_loaderlist.length == 0) 
			{
				timerClose();
				if(_qloaderCompleteFun != null && _qloaderCompleteFun is Function) _qloaderCompleteFun();
			}
		}
		
		/**
		 * check item time over
		 */
		private function checkItems():void
		{
			for (var i:int = 0; i < _loaderlist.length;i++ )
			{
				if (_loaderlist[i]["item"].state == "loading" && _loaderlist[i]["item"].byte == 0)
				{
					_loaderlist[i]["item"].count = 1;
					var k:int = _loaderlist[i]["item"].count;
					if (k > 2 && k < 4)
					{
						_loaderlist[i]["item"].beginload();
					}
					else if(k >= 4)
					{
						_loaderlist[i]["item"].close();
					}
				}
			}
		}
		
		
		private function onItemIOError(params:Object):void
		{
			if(_itemIOErrorFun != null && _itemIOErrorFun is Function) _itemIOErrorFun(params);
		}
		
		private function onItemComplete(params:Object):void
		{
			if(_itemCompleteFun != null && _itemCompleteFun is Function) _itemCompleteFun(params);
		}
		
		private function onItemProgress(params:Object):void
		{
			if(_itemProgressFun != null && _itemProgressFun is Function) _itemProgressFun(params);
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 * timer complete
		 * @param	evt
		 */
		private function timerComplete(evt:TimerEvent):void
		{
			timerClose();
			timerStart();
			checkItems();
		}
	}
}