﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * QloaderItem
 *
 * @version 1.0
 * @since  2011-03-20
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */

package com.activetofocus.utils
{
	import flash.display.Loader;
	import flash.events.EventDispatcher;
	import flash.net.URLLoader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.net.URLRequest;
	import flash.events.ProgressEvent;
	
	public class QloaderItem extends EventDispatcher
	{
		
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 * data
		 */
		private var _url:String;
		private var _params:Object;
		private var _qloader:Qloader;
		
		private var _count:int;
		/**
		 * state
		 */
		private var _loadstate:String = "null";
		
		/**
		 * loader
		 */
		private var _loader:*;
		private var _loadtype:String;
		private var _loaderevent:*;
		private var _byte:Number = 0;
		private var _data:*;
		
		private var _itemIOErrorFun:Function;
		private var _itemCompleteFun:Function;
		private var _itemProgressFun:Function;
		/**
    	 *  constructor
     	 */
		public function QloaderItem(url:String,params:Object = null,qloader:Qloader = null,onItemIOError:Function=null,onItemComplete:Function=null,onItemProgress:Function=null)
		{
			_url 		= url;
			_params		= params || {};
			_qloader 	= qloader;
			_itemIOErrorFun = onItemIOError;
			_itemCompleteFun = onItemComplete;
			_itemProgressFun = onItemProgress;
		}
		
		//--------------------------------------
		//  GET/SET Function
		//--------------------------------------
		
		public function set name(value:String):void
		{
			_params['name'] = value;
		}
		
		public function get name():String
		{
			return _params['name'] || "null";
		}
		
		public function set state(value:String):void
		{
			_loadstate = value;
		}
		
		public function get state():String
		{
			return _loadstate;
		}
		
		public function get loader():*
		{
			return _loader;
		}
		
		public function set count(value:int):void
		{
			_count = value == 0 ? 0 : _count + 1;
		}
		
		public function get count():int
		{
			return _count;
		}
		
		public function get byte():Number
		{
			return _byte;
		}
		
		public function get data():*
		{
			return _data;
		}
		//--------------------------------------
		//  public Function
		//--------------------------------------
		
		/**
		 * close
		 */
		public function close():void
		{
			removeLoader();
			changeState("close");
		}
		
		/**
		 * stop
		 */
		public function stop():void
		{
			//changeState("stop");
			close();
		}
		
		/**
		 * resume
		 */
		public function resume():void
		{
			changeState("resume");
		}
		
		/**
		 *  start load item
		 */
		public function beginload():void
		{
			//trace(_url)
			if (_url == "" || _url.length == 0)
			{
				changeState("loaderror");
				return;
			}
			
			_loadstate = "loading";
			
			removeLoader();
			
			if (_url.indexOf(".swf") != -1 || _url.indexOf(".jpg") != -1 || _url.indexOf(".png") != -1 || _url.indexOf(".gif") != -1)
			{
				_loadtype = "loader"
				_loader = new Loader();
				_loaderevent = _loader.contentLoaderInfo;
				_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
				_loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
				_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoaderCompleteEvent);
			}
			else
			{
				_loadtype = "urlloader";
				_loader = new URLLoader();
				_loaderevent = _loader;
				_loader.addEventListener(IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
				_loader.addEventListener(Event.COMPLETE, onLoaderCompleteEvent);
				_loader.addEventListener(ProgressEvent.PROGRESS, onLoaderProgressEvent);
			}
			_loader.load(new URLRequest(_url));
		}
		
		/**
		 * change loader state
		 * @param	str
		 */
		private function changeState(str:String):void
		{
			_loadstate = str;
			if(_qloader) _qloader.state(this, _loadstate);
		}
		
		/**
		 * remove loader
		 */
		private function removeLoader():void
		{
			if (_loader)
			{
				try
				{
					_loader.close();
					_loader.unload();
				}catch (e:Error) { };
				Clear.removeEvent(_loaderevent,IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
				Clear.removeEvent(_loaderevent,ProgressEvent.PROGRESS, onLoaderProgressEvent);
				Clear.removeEvent(_loaderevent, Event.COMPLETE, onLoaderCompleteEvent);
			}
		}
		
		//--------------------------------------
		//  Private Function
		//--------------------------------------
		
		/**
		 * load error
		 * @param	evt
		 */
		private function onLoaderErrorEvent(evt:IOErrorEvent):void
		{
			Clear.removeEvent(evt.currentTarget,IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			Clear.removeEvent(evt.currentTarget,ProgressEvent.PROGRESS, onLoaderProgressEvent);
			Clear.removeEvent(evt.currentTarget, Event.COMPLETE, onLoaderCompleteEvent);
			changeState("loaderror");
			if(_itemIOErrorFun != null && _itemIOErrorFun is Function) _itemIOErrorFun({target:this,params:_params});
		}
		
		/**
		 * load complete
		 * @param	evt
		 */
		private function onLoaderCompleteEvent(evt:Event):void
		{
			Clear.removeEvent(evt.currentTarget,IOErrorEvent.IO_ERROR, onLoaderErrorEvent);
			Clear.removeEvent(evt.currentTarget,ProgressEvent.PROGRESS, onLoaderProgressEvent);
			Clear.removeEvent(evt.currentTarget, Event.COMPLETE, onLoaderCompleteEvent);
			_data = (_loadtype == "loader") ? evt.currentTarget.loader : evt.currentTarget.data;
			changeState("loadcomplete");
			if(_itemCompleteFun != null && _itemCompleteFun is Function) _itemCompleteFun({target:this,data:_data,params:_params});
		}
		
		/**
		 * load progress
		 * @param	evt
		 */
		private function onLoaderProgressEvent(evt:ProgressEvent):void
		{
			_byte = evt.bytesLoaded;
			if(_itemProgressFun != null && _itemProgressFun is Function) _itemProgressFun({target:this,bytesLoaded:evt.bytesLoaded,bytesTotal:evt.bytesTotal,params:_params});
		}
		
		
	}
}