﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * SlideUtils
 *
 * @version 1.0
 * @since  2010-06-24
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
	
package com.activetofocus.utils
{
	import com.activetofocus.utils.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.IOErrorEvent;
	import flash.display.MovieClip;
    import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
    import flash.net.URLLoader;
	import flash.net.URLRequest;
	import com.activetofocus.events.LoadDataEvent;
	import caurina.transitions.Tweener;
	
	public class SlideUtils extends SuperMovieClip
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  show area
		 */
		private var _sw:Number;
		private var _sh:Number;
		
		private var _id:int;
		
		private var _number:Number = 10;
		
		private var _transition:String = "easeoutexpo";
		private var _spacingWidth:Number;
		private var _spacingHeight:Number;
		
		/**
		 *  delay
		 */
		private var _delay:Number = 1;
		
		/**
		 *  show effect 0 - 8
		 */
		private var _effect:int = 0;
		
		/**
		 *  show object
		 */
		private var _mc:*;
		
		private var _link:String;
		
		private var _target:String; 
		
		/**
		 * start move
		 */
		private var _onStart:Function;
		
		/**
		 * move complete
		 */
		private var _onComplete:Function;
		
		private var _bitmapList:Array;
		
		/**
    	 *  constructor
     	 */
		public function SlideUtils(params:Object = null):void
		{
			_id			= params.id || 0;
			_delay		= params.delay || 0.4;
			_effect		= params.effect || 0;
			_mc			= params.mc;	
			_sw			= params.sw;
			_sh			= params.sh;
			_link       = params.link;
			_target     = params.target;
			_number		= params.number || 10;
			_transition	= params.transition || "easeoutcubic";
			_onStart	= params.onStart || null;
			_onComplete	= params.onComplete || null;
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			Clear.removeEvent(this, MouseEvent.CLICK, onImageClick);
		}
		
		/**
		 * get id
		 */
		public function get id():int 
		{
			return _id;
		}
		 
		/**
		 * stop re call
		 */
		public function close():void
		{
			_onComplete = null;
		}
		
		/**
		 * change background
		 */
		private function init():void
		{
			var k:int = (_effect > 12) ? 0 : _effect;
			
			var _mask = new Sprite();
			_mask.graphics.beginFill(0xff0000, 1);
			_mask.graphics.drawRect(0, 0, _sw, _sh);
			_mask.graphics.endFill();
			addChild(_mask);
			
			this.mask = _mask;
			
			if (k < 5)
			{
				if (k == 0)
				{
					_mc.alpha = 0;
					Tweener.addTween(_mc, { time:_delay,  alpha:1 ,onComplete:onComplete} );
				}
				else if (k == 1)
				{
					_mc.y = -_sh;
					Tweener.addTween(_mc,{time:_delay,y:0,onComplete:onComplete});
				}
				else if (k == 2)
				{
					_mc.y = _sh;
					Tweener.addTween(_mc,{time:_delay,y:0,onComplete:onComplete});
				}
				else if (k == 3)
				{
					_mc.x = -_sw
					Tweener.addTween(_mc,{time:_delay,x:0,onComplete:onComplete});
				}
				else if (k == 4)
				{
					_mc.x = _sw;
					Tweener.addTween(_mc,{time:_delay,x:0,onComplete:onComplete});
				}
				addChild(_mc);
			}
			else
			{
				_bitmapList = [];
				
				_spacingHeight = Math.ceil(_sh / _number);
				_spacingWidth = Math.ceil(_sw / _number);
				
				if (k == 5) addEffect1();
				if (k == 6) addEffect1(true);
				if (k == 7) addEffect2();
				if (k == 8) addEffect2(true);
				if (k == 9) addEffect3();
				if (k == 10) addEffect3(true);
				if (k == 11) addEffect4();
				if (k == 12) addEffect4(true);
			}
		}
		
		/**
		 *  effect 1
		 */
		private function addEffect1(bool:Boolean = false):void
		{
			
		//	var k:int = Math.ceil(_sh / 40);
			
			for (var i:int = 0; i < _number;i++ )
			{
				var sp:Sprite = new Sprite();
				
				var sbmd:BitmapData = new BitmapData(_sw,_sh,true);
				sbmd.draw(_mc);
				
				var bmd:BitmapData = new BitmapData(_sw, _spacingHeight, true);
				bmd.copyPixels(sbmd, new Rectangle(0, i*_spacingHeight, _sw, _spacingHeight), new Point(0, 0));
				
				var bm:Bitmap = new Bitmap(bmd);
				sp.addChild(bm);
				
				sp.y = i * _spacingHeight;
				bm.x = bool ? _sw : -_sw;
				bm.alpha = 0;
				addChild(sp);
				_bitmapList.push({sp:sp,bm:bm,bmd:bmd});
				if(i == _number -1)
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, x:0,alpha:1,transition:_transition,onComplete:onComplete} );
				}
				else
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, x:0,alpha:1,transition:_transition} );
				}
			}
		}
		
		/**
		 *  
		 */
		private function addEffect2(bool:Boolean = false):void
		{
		//	var k:int = Math.ceil(_sw / 43);
			for (var i:int = 0; i < _number;i++ )
			{
				var sp:Sprite = new Sprite();
				
				var sbmd:BitmapData = new BitmapData(_sw,_sh,true);
				sbmd.draw(_mc);
				
				var bmd:BitmapData = new BitmapData(_spacingWidth, _sh, true);
				bmd.copyPixels(sbmd, new Rectangle(i*_spacingWidth, 0, _spacingWidth, _sh), new Point(0, 0));
				
				var bm:Bitmap = new Bitmap(bmd);
				sp.addChild(bm);
				
				sp.x = i * _spacingWidth;
				bm.y = bool ? _sh : -_sh;
				bm.alpha = 0;
				addChild(sp);
				_bitmapList.push({sp:sp,bm:bm,bmd:bmd});
				if(i == _number -1)
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, y:0,alpha:1,transition:_transition,onComplete:onComplete} );
				}
				else
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, y:0,alpha:1,transition:_transition} );
				}
			}
		}
		
		/**
		 *  
		 */
		private function addEffect3(bool:Boolean = false):void
		{
			//var k:int = Math.ceil(_sw / 43);
			for (var i:int = 0; i < _number;i++ )
			{
				var sp:Sprite = new Sprite();
				
				var sbmd:BitmapData = new BitmapData(_sw,_sh,true);
				sbmd.draw(_mc);
				
				var bmd:BitmapData = new BitmapData(_spacingWidth, _sh, true);
				bmd.copyPixels(sbmd, new Rectangle(bool ? i*_spacingWidth : (_number-i-1)*_spacingWidth, 0, _spacingWidth, _sh), new Point(0, 0));
				
				var bm:Bitmap = new Bitmap(bmd);
				sp.addChild(bm);
				
				sp.x = bool ? i * _spacingWidth : (_number-i-1) * _spacingWidth;
				bm.x = bool ? _sw : -_sw;
				bm.alpha = 0;
				addChild(sp);
				_bitmapList.push({sp:sp,bm:bm,bmd:bmd});
				if(i == _number -1)
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, x:0,alpha:1,transition:_transition,onComplete:onComplete} );
				}
				else
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, x:0,alpha:1,transition:_transition} );
				}
			}
		}
		
		/**
		 *  
		 */
		private function addEffect4(bool:Boolean = false):void
		{
			//var k:int = Math.ceil(_sh / 40);
			for (var i:int = 0; i < _number;i++ )
			{
				var sp:Sprite = new Sprite();
				
				var sbmd:BitmapData = new BitmapData(_sw,_sh,true);
				sbmd.draw(_mc);
				
				var bmd:BitmapData = new BitmapData(_sw, _spacingHeight, true);
				bmd.copyPixels(sbmd, new Rectangle(0, bool ? i*_spacingHeight : (_number-i-1) * _spacingHeight, _sw, _spacingHeight), new Point(0, 0));
				
				var bm:Bitmap = new Bitmap(bmd);
				sp.addChild(bm);
				
				sp.y = bool ? i * _spacingHeight : (_number-i-1) * _spacingHeight;
				bm.y = bool ? _sh : -_sh;
				bm.alpha = 0;
				addChild(sp);
				_bitmapList.push({sp:sp,bm:bm,bmd:bmd});
				if(i == _number -1)
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, y:0,alpha:1,transition:_transition,onComplete:onComplete} );
				}
				else
				{
					Tweener.addTween(bm, { time:_delay, delay:0.1 * i, y:0,alpha:1,transition:_transition} );
				}
			}
			
			
			
		}
		
		/**
		 * effect complate
		 */
		private function onComplete():void
		{
			if(_link != "" && _link.length != 0)
			{
				this.buttonMode = true;
				addEventListener(MouseEvent.CLICK, onImageClick);
			}
			
			addChild(_mc);
			
			for each(var obj:* in _bitmapList)
			{
				//trace("delete");
				Clear.removeChild(obj.bm);
				Clear.removeChild(obj.sp);
				try
				{
					obj.bmd.dispose();
				}catch(e:Error){};
				
			}
			
			if(_onComplete != null && _onComplete is Function) _onComplete({id:_id});
		}
		
		/**
		 * image mouse click
		 */
		private function onImageClick(evt:MouseEvent):void
		{
			GetURL.open(_link, _target);
		}
		
	}
}