﻿////////////////////////////////////////////////////////
//
// ActiveToFocus is a professional to provide Flash/Flex technology services team.
//
////////////////////////////////////////////////////////

/**
 * TextUtils
 *
 * @version 1.0
 * @since  2010-09-22
 * @author activetofocus team
 * @author's Blog blog.activetofocus.com
 * @ATF Team Site www.activetofocus.com
 */
	

package com.activetofocus.utils
{
	import caurina.transitions.Tweener;
	import caurina.transitions.Equations;
	import flash.geom.Rectangle;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.geom.Rectangle;
	import flash.text.*;

	public class TextUtils extends Sprite
	{
		
		/**
		 *  textField Mask
		 */
		private var _mask:Sprite;
		private var _height:Number = 10;
		private var _width:Number = 10;
		
		private var _mouseover:Boolean;
		
		private var _delay:Number = 0;
		
		/**
		 *  textField Property
		 */
		private var _textField : TextField;// textField object
		private var _text : String = "";//textField text
		private var _htmlText : String = "";//textField htmltext
		private var _useHtmlText : Boolean;//Whether to use htmltext
		private var _fontSize : int = 12;//textField font size
		private var _color : uint = 0x1b1b1b;//textField font color
		private var _bold : Boolean;//Whether to use bold text
		private var _italic : Boolean //Whether to use italic text
		private var _fontFamily : String = "Arial";//textField font family
		private var _align : String = "left";// textField font align
		private var _selectable : Boolean = true;////Whether to select text area
		private var _spacing:Number = 35;
		
		/**
		 *  Scroll bar properties
		 */
		private var _scrollDelay:Number = 0.5;//scroll delay time
		private var _scrollPanel : Sprite;//scrollbar sprite
		private var _scrollbgPanel : Sprite;//scrollbar background sprite
		private var _scrollWidth : Number = 12;//Scrollbar width
		private var _scrollLineWidth:Number = 2;
		private var _scrollLineColor:uint = 0x5a5a5a;
		private var _scrollBorderColor:uint = 0x2a2a2a;
		private var _scrollColor:uint = 0x1a1a1a;
		private var _scrollAlpha:Number = 1;
		
		/**
		 *  Background Properties
		 */
		private var _useBackground : Boolean = true;//the background state of use textField
		private var _backgroundBorderPanel : Sprite;//the textField Border
		private var _backgroundPanel : Sprite;//the background sprite of textField
		private var _backgroundColor : uint = 0x4b4b4b;//the background color of textField
		private var _backgroundAlpha : Number = 0.35;//textField background alpha
		
		/**
		 * TextUtils Initialization
		 */
		public function TextUtils()
		{	
			this.addEventListener(Event.REMOVED_FROM_STAGE, removeAll);
			
			_mask = new Sprite();
			addChild(_mask);
			
			_backgroundPanel = new Sprite();
			addChild(_backgroundPanel);
			
			_textField = new TextField();
			
			_textField.wordWrap = true;
			_textField.multiline = true;
			_textField.selectable = true;
			_textField.sharpness = 100;
			
			_textField.autoSize = TextFieldAutoSize.LEFT;
			_textField.addEventListener(MouseEvent.MOUSE_WHEEL,scrollTextEvent);
			_textField.addEventListener(Event.CHANGE,changeTextContent);
			addChild(_textField);
		}
		
		/**
		 *  set width/height
		 */
		override public function set width($width : Number):void
		{
			_width = $width;
			_textField.width = $width;
			changeText();
			changeMask();
		}
		
		override public function set height($height : Number):void
		{
			_height = $height;
			changeMask();
		}
		
		/**
		 * set text style
		 */
		public function get text(): String
		{
			return _text;
		}
		
		public function set text($text : String):void
		{
			_text = $text;
			_useHtmlText = false;
			changeText();
		}
		
		public function get htmlText(): String
		{
			return _htmlText;
		}
		
		public function set htmlText($htmlText : String):void
		{
			_htmlText = $htmlText;
			_useHtmlText = true;
			changeText();
		}
		
		public function get fontSize():Number
		{
			return _fontSize;
		}
		
		public function set fontSize($fontSize : Number):void
		{
			_fontSize = $fontSize;
			changeText();
		}
		
		public function get bold():Boolean
		{
			return _bold;
		}
		
		public function set bold($bold : Boolean):void
		{
			_bold = $bold;
			changeText();
		}
		
		public function get italic():Boolean
		{
			return _italic;
		}
		
		public function set italic($italic : Boolean):void
		{
			_italic = $italic;
			changeText();
		}
		
		public function get fontFamily():String
		{
			return _fontFamily;
		}
		
		public function set fontFamily($fontFamily : String):void
		{
			_fontFamily = $fontFamily;
			changeText();
		}
		
		public function get align():String
		{
			return _align;
		}
		
		public function set align($align : String):void
		{
			_align = $align;
			changeText();
		}
		
		public function get color():uint
		{
			return _color;
		}
		
		public function set color($color : uint):void
		{
			_color = $color;
			changeText();
		}
		
		public function get selectable():Boolean
		{
			return _selectable;
		}
		
		public function set selectable($selectable : Boolean):void
		{
			_textField.selectable = _selectable = $selectable;
		}
		
		/**
		 * scroll style
		 */
		public function set scrollcolor($value:uint):void
		{
			_scrollColor = $value;
		}
		
		public function set scrolllinecolor(value:uint):void
		{
			_scrollLineColor = value;
		}
		
		public function set scrollbordercolor(value:uint):void
		{
			_scrollBorderColor = value;
		}
		
		public function set scrollalpha(value:Number):void
		{
			_scrollAlpha = value;
		}
		
		/**
		 *  set text background
		 */
		public function get useBackground():Boolean
		{
			return _useBackground;
		}
		
		public function set useBackground($useBackground : Boolean):void
		{
			_useBackground = $useBackground;
			changeText();
		}
		
		public function get backgroundColor():uint
		{
			return _backgroundColor;
		}
		
		public function set backgroundColor($backgroundColor : uint):void
		{
			_backgroundColor = $backgroundColor;
			changeText();
		}
		
		public function get backgroundAlpha():Number
		{
			return _backgroundAlpha;
		}
		
		public function set backgroundAlpha($backgroundAlpha : Number):void
		{
			_backgroundAlpha = $backgroundAlpha;
			changeText();
		}
		
		/**
		 *  set mouse over effect
		 */
		
		public function set mouseover(value:Boolean):void
		{
			_mouseover = value;
			if(_textField.hasEventListener(MouseEvent.MOUSE_WHEEL)) _textField.removeEventListener(MouseEvent.MOUSE_WHEEL,scrollTextEvent);
			if(_textField.hasEventListener(MouseEvent.MOUSE_MOVE)) _textField.removeEventListener(MouseEvent.MOUSE_MOVE, onMouseMoveEvent);
			if (_mouseover)
			{
				_textField.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMoveEvent);
			}
			else
			{
				_textField.addEventListener(MouseEvent.MOUSE_WHEEL,scrollTextEvent);
			}
		}
		
		private function onMouseMoveEvent(evt:MouseEvent):void
		{
			if (_textField.textHeight < _height) return;
			var k:Number = (this.mouseY / _height)*(_height-_scrollPanel.height);
			_scrollPanel.y = k;
			if(_scrollPanel.y < 0) _scrollPanel.y = 0;
			if(_scrollPanel.y > _height-_scrollPanel.height) _scrollPanel.y = _height-_scrollPanel.height;
			startDragMove();
		}
		
		/**
		 *  _mask change
		 */
		private function changeMask():void
		{
			this.mask = _mask;
			_mask.graphics.clear();
			_mask.graphics.beginFill(0xff0000,0.5);
			_mask.graphics.drawRect(0,0,_width,_height);
			_mask.graphics.endFill();
		}
		
		/**
		 * TextUtils change the implementation of relevant attributes
		 */
		public function changeText():void
		{
			if(_useHtmlText)
			{
				_textField.htmlText = _htmlText;
			}
			else
			{
				_textField.text = _text;
				_textField.setTextFormat(returnTextFormat());
			}
			changeTextContent();
		}
		
		/**
		 * Editable text in the implementation of change
		 */
		private function changeTextContent($e : Event = null):void
		{
			if(_textField.textHeight > _height)
			{
				_textField.width = _width - _scrollWidth;
				addscrollBGPanel(true);
				addscrollPanel(true);
			}
			else
			{
				_textField.width = this.width;
				addscrollBGPanel(false);
				addscrollPanel(false);
			}
			setBackgroundColor();
		}
		
		/**
		 * Set TextUtils Background
		 */
		private function setBackgroundColor():void
		{
			_backgroundPanel.graphics.clear();
			_backgroundPanel.graphics.beginFill(_backgroundColor,_backgroundAlpha);
			_backgroundPanel.graphics.drawRect(0,0,_textField.width,_height);
			_backgroundPanel.graphics.endFill();
			if(_useBackground)
			{
				_backgroundPanel.visible = true;
			}
			else
			{
				_backgroundPanel.visible = false;
			}
		}
		
		/**
		 * Add a scroll bar background to
		 */
		private function addscrollBGPanel($bool : Boolean):void
		{
			if(!$bool)
			{
				if(_scrollbgPanel)
				{
					_scrollbgPanel.visible = false;
				}
				return;
			}
			if(!_scrollbgPanel)
			{
				_scrollbgPanel = new Sprite();
				_scrollbgPanel.x = this.width - _scrollWidth/2;
				_scrollbgPanel.graphics.beginFill(_scrollLineColor,1)
				_scrollbgPanel.graphics.drawRect(0,0,_scrollLineWidth,_height)
				_scrollbgPanel.graphics.endFill();
				addChild(_scrollbgPanel);
			}
			_scrollbgPanel.visible = true;
		}
		
		/**
		 * Add TextUtils scroll bar
		 */
		private function addscrollPanel($bool : Boolean):void
		{
			if(!$bool)
			{
				if(_scrollPanel) _scrollPanel.graphics.clear();
				return;
			}
			if(_scrollPanel)
			{
				_scrollPanel.graphics.clear();
				_scrollPanel.y = 0;
			}
			else
			{
				_scrollPanel = new Sprite();
				_scrollPanel.x = this.width - _scrollWidth + 4;
				_scrollPanel.buttonMode = true;
				_scrollPanel.addEventListener(MouseEvent.MOUSE_DOWN,startDragscroll);
				addChild(_scrollPanel);
			}
			_scrollPanel.graphics.lineStyle(1,_scrollBorderColor)
			_scrollPanel.graphics.beginFill(_scrollColor,1)
			
			_scrollPanel.graphics.drawRect(-0.5,0.5,_scrollWidth - 5, (_height/_textField.textHeight) * _height - 1)
			_scrollPanel.graphics.endFill();
		}
		
		/**
		 * Start dragging the scroll bar
		 */
		private function startDragscroll($e : MouseEvent):void
		{
			_scrollPanel.alpha = _scrollAlpha;
			_scrollPanel.startDrag(false,new Rectangle(this.width - _scrollWidth + 4,0,0,_height-_scrollPanel.height));
			this.stage.addEventListener(MouseEvent.MOUSE_MOVE,startDragMove);
			this.stage.addEventListener(MouseEvent.MOUSE_UP,stopDragMove);
		}
		
		/**
		 * Stop dragging the scroll bar
		 */
		private function stopDragMove($e : MouseEvent = null):void
		{
			_scrollPanel.alpha = 1;
			_scrollPanel.stopDrag();
			this.stage.removeEventListener(MouseEvent.MOUSE_MOVE,startDragMove);
			this.stage.removeEventListener(MouseEvent.MOUSE_UP,stopDragMove);
		}
		
		/**
		 * Drag the scroll bar is being
		 */
		private function startDragMove($e : MouseEvent = null):void
		{
			var i:Number = - (_scrollPanel.y/(_height-_scrollPanel.height))*(_textField.textHeight-_height);
			Tweener.addTween(_textField,{y:i,time:0.5,delay:_delay});
		}
		
		/**
		 * textField Scroll event is triggered
		 */
		private function scrollTextEvent($e : MouseEvent):void
		{
			if(!_scrollPanel) return;
			if (int($e.delta) > 0)
			{
				if (_scrollPanel.y >= 0)
				{
					_scrollPanel.y += -getSpacing();
					if(_scrollPanel.y < 0) _scrollPanel.y = 0;
					startDragMove();
				}
			}
			else
			{
				if (_scrollPanel.y <= _height-_scrollPanel.height)
				{
					_scrollPanel.y += getSpacing();
					if(_scrollPanel.y > _height-_scrollPanel.height) _scrollPanel.y = _height-_scrollPanel.height;
					startDragMove();
				}
			}
		}
		
		/**
		 *  get spacing
		 */
		private function getSpacing():Number
		{
			return (_spacing/(_textField.textHeight - _height)) * (_height-_scrollPanel.height);
		}
		
		/**
		 * Set textField Format
		 */
		private function returnTextFormat():TextFormat
		{
			var font : TextFormat = new TextFormat();
			font.font = _fontFamily;
			font.size = _fontSize;
			font.align = _align;
			font.color = _color;
			return font;
		}

		/**
		 *   removeEventListener
		 */
		private function removeAll(evt:Event):void
		{
			this.removeEventListener(Event.REMOVED_FROM_STAGE,removeAll);
			_textField.removeEventListener(MouseEvent.MOUSE_WHEEL,scrollTextEvent);
			_textField.removeEventListener(Event.CHANGE,changeTextContent);
			if(_textField.hasEventListener(MouseEvent.MOUSE_WHEEL)) _textField.removeEventListener(MouseEvent.MOUSE_WHEEL,scrollTextEvent);
			if(_textField.hasEventListener(MouseEvent.MOUSE_MOVE)) _textField.removeEventListener(MouseEvent.MOUSE_MOVE, onMouseMoveEvent);
		}
	}
}