﻿package com.activetofocus.video.components
{
	import com.activetofocus.video.events.VideoPlayerMenuComponentsEvent;
	import com.activetofocus.utils.*;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.events.Event;
	import flash.display.StageDisplayState;
	import flash.text.TextField;
	
	/**
	 * VideoPlayerMenuComponents
	 *
	 * @author activetofocus team
	 * @since  2010-04-12
	 */
	public class VideoPlayerMenuComponents extends SuperMovieClip
	{
		//--------------------------------------
		//  Variables
		//--------------------------------------
		
		/**
		 *  data
		 */
		private var _isPlay:Boolean;//video play state
		private var _isFullscreen:Boolean;// fullscree state
		private var _isSoundOpen:Boolean;// sound open state
		private var nowSoundValue:int;// sound value
		private var _progLength:Number = 260;// progress width
		
		/**
    	 *  constructor
     	 */
		public function VideoPlayerMenuComponents()
		{
			
		}
		
		//--------------------------------------
		//  Override Function
		//--------------------------------------
		
		/**
		 * add to stage
		 */
		override public function initialize():void 
		{
			this.stage.addEventListener(Event.RESIZE, onStageResize);
			init()
		} 
		
		/**
		 * remove from stage
		 */
		override public function destroy():void 
		{
			Clear.removeEvent(this.stage, Event.RESIZE, onStageResize);
		}
		
		//--------------------------------------
		//  Function
		//--------------------------------------
		
		/**
		 *  data init
		 */
		private function init():void
		{
			cuttime_txt.selectable = false;
			tagtime_txt.selectable = false;
			
			vp_pro.prog.width = 0;
			vp_pro.prog.mouseEnabled = false;
			
			vp_pro.buffprog.width = 0;
			vp_pro.buffprog.buttonMode = true;
			vp_pro.buffprog.addEventListener(MouseEvent.MOUSE_DOWN,onProgMouseDown);
			
			vp_start.buttonMode = true;
			vp_start.mouseChildren = false;
			vp_start.addEventListener(MouseEvent.CLICK,onButtonMouseClick);
			vp_start.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);
			vp_start.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			
			vp_stop.buttonMode = true;
			vp_stop.mouseChildren = false;
			vp_stop.addEventListener(MouseEvent.CLICK,onButtonMouseClick);
			vp_stop.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);
			vp_stop.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);
			
			vp_sound.sc.buttonMode = true;
			vp_sound.sc.mouseChildren = false;
			vp_sound.sc.addEventListener(MouseEvent.CLICK,onButtonMouseClick);
			vp_sound.sc.addEventListener(MouseEvent.MOUSE_OVER,onButtonMouseOver);
			vp_sound.sc.addEventListener(MouseEvent.MOUSE_OUT,onButtonMouseOut);

			for(var i:int = 1; i < 11; i++)
			{
				vp_sound["s_"+i].x = 36 + (i-1) * (4 + 1);
				vp_sound["s_"+i].buttonMode = true;
				vp_sound["s_"+i].addEventListener(MouseEvent.CLICK,onSoundButtonMouseClick);
			}
		}
		
		/**
		 *  change sound value
		 */
		public function changeSoundValue(value:int):void
		{
			nowSoundValue = value;
			for(var i:int = 1; i < 11; i++)
			{
				if(i <= nowSoundValue) 
				{
					vp_sound["s_"+i].gotoAndStop(1);
				}
				else
				{
					vp_sound["s_"+i].gotoAndStop(2);
				}
			}
		}
		
		/**
		 *  get time string
		 */
		private function timeString(ti:Number):String 
		{
			ti 				= Math.round(ti);
			var hors:Number 	= Math.floor(ti / 3600);
			var mins:Number 	= Math.floor((ti % 3600) / 60);
			var secs:Number 	= Math.round((ti % 3600) % 60);
			
			var horsStr:String = (hors < 10 ? "0" : "") + String(hors); 
			var minsStr:String = (mins < 10 ? "0" : "") + String(mins); 
			var secsStr:String = (secs < 10 ? "0" : "") + String(secs);
			
			return (hors > 0) ? horsStr + ":" + minsStr + ":" + secsStr : minsStr + ":" + secsStr;
		}
		
		//--------------------------------------
		// PUBLIC FUNCTION
		//--------------------------------------
		
		/**
		 *  change play state
		 */
		public function changePlayState(bool:Boolean):void
		{
			_isPlay = bool;
			if(_isPlay)
			{
				vp_start.gotoAndStop(3);
			}
			else
			{
				vp_start.gotoAndStop(1);
			}
		}
		
		/**
		 *  change buffer progress width
		 */
		public function changeLoadProgress(value:Number):void
		{
		//	trace(value,vp_pro.buffprog);
			vp_pro.buffprog.width = value * _progLength;
		}
		
		/**
		 *  change play progress
		 */
		public function changePlayProgress(currentTime:Number,totalTime:Number):void
		{
			vp_pro.prog.width = Number(currentTime / totalTime) * _progLength;
			cuttime_txt.text = timeString(currentTime);
			tagtime_txt.text = timeString(totalTime);
		}
		
		//--------------------------------------
		//  Event
		//--------------------------------------
		
		/**
		 *  stage resize
		 */
		public function onStageResize(evt:Event):void
		{
		
		}
		
		/**
		 *  button mouse click event
		 */
		private function onButtonMouseClick(evt:MouseEvent):void
		{
			if(evt.currentTarget == vp_start)
			{
				if(_isPlay)
				{
					dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_STOP));}
				else
				{
					dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_PLAY));
				}
			}
			else if(evt.currentTarget == vp_stop)
			{
				dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_STOP_ALL));
			}
			else if(evt.currentTarget == vp_sound.sc)
			{
				_isSoundOpen = !_isSoundOpen;
				!_isSoundOpen ? evt.currentTarget.gotoAndStop(2) : evt.currentTarget.gotoAndStop(4)
				dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.SOUND_CHANGE,{volume:(_isSoundOpen ? 0 : 5)}));
			}
		}
		
		/**
		 *  button mouse over event
		 */
		private function onButtonMouseOver(evt:MouseEvent):void
		{
			//if(evt.currentTarget == vp_start && _isPlay || evt.currentTarget == vp_stop && !_isPlay) return;
			if(evt.currentTarget == vp_start)
			{
				if(_isPlay)
				{
					vp_start.gotoAndStop(4);
				}
				else
				{
					vp_start.gotoAndStop(2);
				}
				return;
			}
			if(evt.currentTarget == vp_sound.sc)
			{
				!_isSoundOpen ? evt.currentTarget.gotoAndStop(2) : evt.currentTarget.gotoAndStop(4)
				return;
			}
			evt.currentTarget.gotoAndStop(2);
		}
		
		/**
		 *  button mouse out event
		 */
		private function onButtonMouseOut(evt:MouseEvent):void
		{
			//if(evt.currentTarget == vp_start && _isPlay || evt.currentTarget == vp_stop && !_isPlay) return; 
			if(evt.currentTarget == vp_start)
			{
				if(_isPlay)
				{
					vp_start.gotoAndStop(3);
				}
				else
				{
					vp_start.gotoAndStop(1);
				}
				return;
			}
			if(evt.currentTarget == vp_sound.sc)
			{
				!_isSoundOpen ? evt.currentTarget.gotoAndStop(1) : evt.currentTarget.gotoAndStop(3)
				return;
			}
			evt.currentTarget.gotoAndStop(1);
		}
		
		/**
		 *  flag mouse down event
		 */
		private function onMoveFlagMouseDown(evt:MouseEvent):void
		{
			this.stage.addEventListener(MouseEvent.MOUSE_UP,onMoveFlagMouseUp);
			this.stage.addEventListener(MouseEvent.MOUSE_MOVE,onMoveFlagMouseMove);
			dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_STOP,{flag:true}));
			evt.currentTarget.startDrag(true,new Rectangle(vp_pro.prog.x, evt.currentTarget.parent.height/2, vp_pro.buffprog.width, 0));
		}
		
		/**
		 *  prog mouse down
		 */
		private function onProgMouseDown(evt:MouseEvent):void
		{
			var k:Number = evt.currentTarget.mouseX;
			vp_pro.prog.width = Number(k * _progLength);
			dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_SEEK,k));
		}
		
		/**
		 *  flag mouse move event
		 */
		private function onMoveFlagMouseMove(evt:MouseEvent):void
		{
			//trace(Number(vp_pro.moveflag.x - vp_pro.prog.x));
			dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_SEEK,Number((Number(vp_pro.moveflag.x - vp_pro.prog.x)/_progLength))));
		}
		
		/**
		 *  flag mouse out event
		 */
		private function onMoveFlagMouseUp(evt:MouseEvent):void
		{
			this.stage.removeEventListener(MouseEvent.MOUSE_UP,onMoveFlagMouseUp);
			this.stage.removeEventListener(MouseEvent.MOUSE_MOVE,onMoveFlagMouseMove);
			vp_pro.moveflag.stopDrag();
			dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.VIDEO_PLAY));
		}
		
		/**
		 *  sound value change
		 */
		private function onSoundButtonMouseClick(evt:MouseEvent):void
		{
			_isSoundOpen = false;
			vp_sound.sc.gotoAndStop(1);
			var k:int = int(evt.currentTarget.name.split("_")[1]);
			dispatchEvent(new VideoPlayerMenuComponentsEvent(VideoPlayerMenuComponentsEvent.SOUND_CHANGE,{volume:k}));
		}
	}
}